Package: megadepth
Title: megadepth: BigWig and BAM related utilities
Version: 1.16.0
Date: 2021-08-05
Authors@R: 
    c(
    person(
        "Leonardo", "Collado-Torres", role = c("aut"), 
        email = "lcolladotor@gmail.com",
        comment = c(ORCID = "0000-0003-2140-308X")
    ),
    person(
        given = "David",
        family = "Zhang",
        role = c("aut", "cre"),
        email = "david.zhang.12@ucl.ac.uk",
        comment = c(ORCID = "0000-0003-2382-8460")
    ))
Description: This package provides an R interface to Megadepth by Christopher
    Wilks available at https://github.com/ChristopherWilks/megadepth. It is
    particularly useful for computing the coverage of a set of genomic regions
    across bigWig or BAM files. With this package, you can build base-pair
    coverage matrices for regions or annotations of your choice from BigWig
    files. Megadepth was used to create the raw files provided by
    https://bioconductor.org/packages/recount3.
License: Artistic-2.0
URL: https://github.com/LieberInstitute/megadepth
BugReports: https://support.bioconductor.org/t/megadepth
biocViews: Software, Coverage, DataImport, Transcriptomics, RNASeq,
        Preprocessing
Encoding: UTF-8
Roxygen: list(markdown = TRUE)
RoxygenNote: 7.2.3
Suggests: covr, knitr, BiocStyle, sessioninfo, rmarkdown, rtracklayer,
        derfinder, GenomeInfoDb, tools, RefManageR, testthat
SystemRequirements: megadepth
        (<https://github.com/ChristopherWilks/megadepth>)
VignetteBuilder: knitr
Imports: xfun, utils, fs, GenomicRanges, readr, cmdfun, dplyr, magrittr
Config/testthat/edition: 3
git_url: https://git.bioconductor.org/packages/megadepth
git_branch: RELEASE_3_20
git_last_commit: d7f5e2d
git_last_commit_date: 2024-10-29
Repository: Bioconductor 3.20
Date/Publication: 2024-10-29
NeedsCompilation: no
Packaged: 2024-10-30 01:28:03 UTC; biocbuild
Author: Leonardo Collado-Torres [aut] (<https://orcid.org/0000-0003-2140-308X>),
  David Zhang [aut, cre] (<https://orcid.org/0000-0003-2382-8460>)
Maintainer: David Zhang <david.zhang.12@ucl.ac.uk>

<!-- README.md is generated from README.Rmd. Please edit that file -->

# megadepth

<!-- badges: start -->

[![Lifecycle:
stable](https://img.shields.io/badge/lifecycle-stable-brightgreen.svg)](https://lifecycle.r-lib.org/articles/stages.html#stable)
[![Bioc release
status](http://www.bioconductor.org/shields/build/release/bioc/megadepth.svg)](https://bioconductor.org/checkResults/release/bioc-LATEST/megadepth)
[![Bioc devel
status](http://www.bioconductor.org/shields/build/devel/bioc/megadepth.svg)](https://bioconductor.org/checkResults/devel/bioc-LATEST/megadepth)
[![Bioc downloads
rank](https://bioconductor.org/shields/downloads/release/megadepth.svg)](http://bioconductor.org/packages/stats/bioc/megadepth/)
[![Bioc
support](https://bioconductor.org/shields/posts/megadepth.svg)](https://support.bioconductor.org/tag/megadepth)
[![Bioc
history](https://bioconductor.org/shields/years-in-bioc/megadepth.svg)](https://bioconductor.org/packages/release/bioc/html/megadepth.html#since)
[![Bioc last
commit](https://bioconductor.org/shields/lastcommit/devel/bioc/megadepth.svg)](http://bioconductor.org/checkResults/devel/bioc-LATEST/megadepth/)
[![Bioc
dependencies](https://bioconductor.org/shields/dependencies/release/megadepth.svg)](https://bioconductor.org/packages/release/bioc/html/megadepth.html#since)
[![Codecov test
coverage](https://codecov.io/gh/LieberInstitute/megadepth/branch/devel/graph/badge.svg)](https://codecov.io/gh/LieberInstitute/megadepth?branch=devel)
[![R build
status](https://github.com/LieberInstitute/megadepth/workflows/R-CMD-check-bioc/badge.svg)](https://github.com/LieberInstitute/megadepth/actions)
[![GitHub
issues](https://img.shields.io/github/issues/LieberInstitute/megadepth)](https://github.com/LieberInstitute/megadepth/issues)
[![GitHub
pulls](https://img.shields.io/github/issues-pr/LieberInstitute/megadepth)](https://github.com/LieberInstitute/megadepth/pulls)
<!-- badges: end -->

The goal of `megadepth` is to provide an R interface to the command line
tool [Megadepth](https://github.com/ChristopherWilks/megadepth) for
BigWig and BAM related utilities created by [Christopher
Wilks](https://twitter.com/chrisnwilks). This R package enables **fast**
processing of BigWig files on downstream packages such as
[dasper](https://bioconductor.org/packages/dasper) and
[recount3](https://bioconductor.org/packages/recount3). The
[Megadepth](https://github.com/ChristopherWilks/megadepth) software also
provides utilities for processing BAM files and extracting coverage
information from them.

Here is an illustration on how fast `megadepth` is compared to other
tools for processing local and remote BigWig files.

<a href="https://github.com/LieberInstitute/megadepth/tree/devel/analysis"><img src="https://raw.githubusercontent.com/LieberInstitute/megadepth/devel/analysis/md_rt_pybw_runtime.png" width="800px" ></a>

Throughout the documentation we use a capital `M` to refer to the
software by Christopher Wilks and a lower case `m` to refer to this
R/Bioconductor package.

## Installation instructions

Get the latest stable `R` release from
[CRAN](http://cran.r-project.org/). Then install `megadepth` from
[Bioconductor](http://bioconductor.org/) using the following code:

``` r
if (!requireNamespace("BiocManager", quietly = TRUE)) {
    install.packages("BiocManager")
}

BiocManager::install("megadepth")
```

And the development version from [GitHub](https://github.com/) with:

``` r
BiocManager::install("LieberInstitute/megadepth")
```

## Example

In the following example, we install
[Megadepth](https://github.com/ChristopherWilks/megadepth) with
`install_megadepth()`, which downloads a binary for your OS (Linux,
Windows or macOS). We can then use with an example BigWig file to
compute the coverage at a set of regions.

``` r
## Load the R package
library("megadepth")

## Install Megadepth's pre-compiled binary on your system
install_megadepth()
#> It seems megadepth has been installed. Use force = TRUE to reinstall or upgrade.

## Next, we locate the example BigWig and annotation files
example_bw <- system.file("tests", "test.bam.all.bw",
    package = "megadepth", mustWork = TRUE
)
annotation_file <- system.file("tests", "testbw2.bed",
    package = "megadepth", mustWork = TRUE
)

## We can then use megadepth to compute the coverage
bw_cov <- get_coverage(example_bw, op = "mean", annotation = annotation_file)
bw_cov
#> GRanges object with 4 ranges and 1 metadata column:
#>         seqnames          ranges strand |     score
#>            <Rle>       <IRanges>  <Rle> | <numeric>
#>   [1]      chr10            0-10      * |      0.00
#>   [2]      chr10 8756697-8756762      * |     15.85
#>   [3]      chr10 4359156-4359188      * |      3.00
#>   [4] GL000219.1   168500-168620      * |      1.26
#>   -------
#>   seqinfo: 2 sequences from an unspecified genome; no seqlengths
```

## Full set of utilities

[Megadepth](https://github.com/ChristopherWilks/megadepth) is very
powerful and can do a lot of different things. The R/Bioconductor
package provides two functions for interfacing with
[Megadepth](https://github.com/ChristopherWilks/megadepth),
`megadepth_cmd()` and `megadepth_shell()`. For the first one,
`megadepth_cmd()`, you need to know the actual command syntax you want
to use and format it accordingly. If you are more comfortable with R
functions, `megadepth_shell()` uses
*[cmdfun](https://CRAN.R-project.org/package=cmdfun)* to power this
interface and capture the standard output stream into R.

To make it easier to use, `megadepth` includes functions that simplify
the number of arguments, read in the output files, and converts them
into R/Bioconductor friendly objects, such as `get_coverage()`
illustrated above.

We hope that you’ll find `megadepth` and
[Megadepth](https://github.com/ChristopherWilks/megadepth) useful for
your work. If you are interested in checking how **fast** `megadepth`
is, check out the [**speed
analysis**](https://github.com/LieberInstitute/megadepth/tree/devel/analysis)
comparison against other tools. Note that the size of the files used and
the number of genomic regions queried will affect the speed comparisons.

``` r
## R-like interface
## that captures the standard output into R
head(megadepth_shell(help = TRUE))
#> [1] "megadepth 1.2.0"                  ""                                
#> [3] "BAM and BigWig utility."          ""                                
#> [5] "Usage:"                           "  megadepth <bam|bw|-> [options]"

## Command-like interface
megadepth_cmd("--help")
```

    #> megadepth 1.2.0
    #>  
    #>  BAM and BigWig utility.
    #>  
    #>  Usage:
    #>    megadepth <bam|bw|-> [options]
    #>  
    #>  Options:
    #>    -h --help                Show this screen.
    #>    --version                Show version.
    #>    --threads                # of threads to do: BAM decompression OR compute sums over multiple BigWigs in parallel
    #>                              if the 2nd is intended then a TXT file listing the paths to the BigWigs to process in parallel
    #>                              should be passed in as the main input file instead of a single BigWig file (EXPERIMENTAL).
    #>    --prefix                 String to use to prefix all output files.
    #>    --no-auc-stdout          Force all AUC(s) to be written to <prefix>.auc.tsv rather than STDOUT
    #>    --no-annotation-stdout   Force summarized annotation regions to be written to <prefix>.annotation.tsv rather than STDOUT
    #>    --no-coverage-stdout     Force covered regions to be written to <prefix>.coverage.tsv rather than STDOUT
    #>    --keep-order             Output annotation coverage in the order chromosomes appear in the BAM/BigWig file
    #>                             The default is to output annotation coverage in the order chromosomes appear in the annotation BED file.
    #>                             This is only applicable if --annotation is used for either BAM or BigWig input.
    #>  
    #>  BigWig Input:
    #>  Extract regions and their counts from a BigWig outputting BED format if a BigWig file is detected as input (exclusive of the other BAM modes):
    #>                                            Extracts all reads from the passed in BigWig and output as BED format.
    #>                                             This will also report the AUC over the annotated regions to STDOUT.
    #>                                             If only the name of the BigWig file is passed in with no other args, it will *only* report total AUC to STDOUT.
    #>    --annotation <bed>                      Only output the regions in this BED applying the argument to --op to them.
    #>    --op <sum[default], mean, min, max>     Statistic to run on the intervals provided by --annotation
    #>    --sums-only                             Discard coordinates from output of summarized regions
    #>    --distance (2200[default])              Number of base pairs between end of last annotation and start of new to consider in the same BigWig query window (a form of binning) for performance.  This determines the number of times the BigWig index is queried.
    #>    --unsorted (off[default])               There's a performance improvement *if* BED file passed to --annotation is 1) sorted by sort -k1,1 -k2,2n (default is to assume sorted and check for unsorted positions, if unsorted positions are found, will fall back to slower version)
    #>    --bwbuffer <1GB[default]>               Size of buffer for reading BigWig files, critical to use a large value (~1GB) for remote BigWigs.
    #>                                            Default setting should be fine for most uses, but raise if very slow on a remote BigWig.
    #>  
    #>  
    #>  BAM Input:
    #>  Extract basic junction information from the BAM, including co-occurrence
    #>  If only the name of the BAM file is passed in with no other args, it will *only* report total AUC to STDOUT.
    #>    --fasta              Path to the reference FASTA file if a CRAM file is passed as the input file (ignored otherwise)
    #>                         If not passed, references will be downloaded using the CRAM header.
    #>    --junctions          Extract co-occurring jx coordinates, strand, and anchor length, per read
    #>                         writes to a TSV file <prefix>.jxs.tsv
    #>    --all-junctions      Extract all jx coordinates, strand, and anchor length, per read for any jx
    #>                         writes to a TSV file <prefix>.all_jxs.tsv
    #>    --longreads          Modifies certain buffer sizes to accommodate longer reads such as PB/Oxford.
    #>    --filter-in          Integer bitmask, any bits of which alignments need to have to be kept (similar to samtools view -f).
    #>    --filter-out         Integer bitmask, any bits of which alignments need to have to be skipped (similar to samtools view -F).
    #>    --add-chr-prefix     Adds "chr" prefix to relevant chromosomes for BAMs w/o it, pass "human" or "mouse".
    #>                         Only works for human/mouse references (default: off).
    #>  
    #>  Non-reference summaries:
    #>    --alts                       Print differing from ref per-base coverages
    #>                                 Writes to a CSV file <prefix>.alts.tsv
    #>    --include-softclip           Print a record to the alts CSV for soft-clipped bases
    #>                                 Writes total counts to a separate TSV file <prefix>.softclip.tsv
    #>    --only-polya                 If --include-softclip, only print softclips which are mostly A's or T's
    #>    --include-n                  Print mismatch records when mismatched read base is N
    #>    --print-qual                 Print quality values for mismatched bases
    #>    --delta                      Print POS field as +/- delta from previous
    #>    --require-mdz                Quit with error unless MD:Z field exists everywhere it's
    #>                                 expected
    #>    --head                       Print sequence names and lengths in SAM/BAM header
    #>  
    #>  Coverage and quantification:
    #>    --coverage           Print per-base coverage (slow but totally worth it)
    #>    --auc                Print per-base area-under-coverage, will generate it for the genome
    #>                         and for the annotation if --annotation is also passed in
    #>                         Defaults to STDOUT, unless other params are passed in as well, then
    #>                         if writes to a TSV file <prefix>.auc.tsv
    #>    --bigwig             Output coverage as BigWig file(s).  Writes to <prefix>.bw
    #>                         (also <prefix>.unique.bw when --min-unique-qual is specified).
    #>                         Requires libBigWig.
    #>    --annotation <BED|window_size>   Path to BED file containing list of regions to sum coverage over
    #>                         (tab-delimited: chrm,start,end). Or this can specify a contiguous region size in bp.
    #>    --op <sum[default], mean>     Statistic to run on the intervals provided by --annotation
    #>    --no-index           If using --annotation, skip the use of the BAM index (BAI) for pulling out regions.
    #>                         Setting this can be faster if doing windows across the whole genome.
    #>                         This will be turned on automatically if a window size is passed to --annotation.
    #>    --min-unique-qual <int>
    #>                         Output second bigWig consisting built only from alignments
    #>                         with at least this mapping quality.  --bigwig must be specified.
    #>                         Also produces second set of annotation sums based on this coverage
    #>                         if --annotation is enabled
    #>    --double-count       Allow overlapping ends of PE read to count twice toward
    #>                         coverage
    #>    --num-bases          Report total sum of bases in alignments processed (that pass filters)
    #>    --gzip               Turns on gzipping of coverage output (no effect if --bigwig is passsed),
    #>                         this will also enable --no-coverage-stdout.
    #>  
    #>  Other outputs:
    #>    --read-ends          Print counts of read starts/ends, if --min-unique-qual is set
    #>                         then only the alignments that pass that filter will be counted here
    #>                         Writes to 2 TSV files: <prefix>.starts.tsv, <prefix>.ends.tsv
    #>    --frag-dist          Print fragment length distribution across the genome
    #>                         Writes to a TSV file <prefix>.frags.tsv
    #>    --echo-sam           Print a SAM record for each aligned read
    #>    --ends               Report end coordinate for each read (useful for debugging)
    #>    --test-polya         Lower Poly-A filter minimums for testing (only useful for debugging/testing)
    #>  
    #> 

## Citation

Below is the citation output from using `citation('megadepth')` in R.
Please run this yourself to check for any updates on how to cite
**megadepth**.

``` r
print(citation("megadepth"), bibtex = TRUE)
#> To cite package 'megadepth' in publications use:
#> 
#>   Zhang D, Collado-Torres L (2023). _megadepth: BigWig and BAM related
#>   utilities_. doi:10.18129/B9.bioc.megadepth
#>   <https://doi.org/10.18129/B9.bioc.megadepth>,
#>   https://github.com/LieberInstitute/megadepth - R package version
#>   1.11.0, <http://www.bioconductor.org/packages/megadepth>.
#> 
#> A BibTeX entry for LaTeX users is
#> 
#>   @Manual{,
#>     title = {megadepth: BigWig and BAM related utilities},
#>     author = {David Zhang and Leonardo Collado-Torres},
#>     year = {2023},
#>     url = {http://www.bioconductor.org/packages/megadepth},
#>     note = {https://github.com/LieberInstitute/megadepth - R package version 1.11.0},
#>     doi = {10.18129/B9.bioc.megadepth},
#>   }
#> 
#>   Wilks C, Ahmed O, Baker DN, Zhang D, Collado-Torres L, Langmead B
#>   (2020). "Megadepth: efficient coverage quantification for BigWigs and
#>   BAMs." _bioRxiv_. doi:10.1101/2020.12.17.423317
#>   <https://doi.org/10.1101/2020.12.17.423317>,
#>   <https://www.biorxiv.org/content/10.1101/2020.12.17.423317v1>.
#> 
#> A BibTeX entry for LaTeX users is
#> 
#>   @Article{,
#>     title = {Megadepth: efficient coverage quantification for BigWigs and BAMs},
#>     author = {Christopher Wilks and Omar Ahmed and Daniel N. Baker and David Zhang and Leonardo Collado-Torres and Ben Langmead},
#>     year = {2020},
#>     journal = {bioRxiv},
#>     doi = {https://doi.org/10.1101/2020.12.17.423317},
#>     url = {https://www.biorxiv.org/content/10.1101/2020.12.17.423317v1},
#>   }
```

Please note that the `megadepth` was only made possible thanks to many
other R and bioinformatics software authors, which are cited either in
the vignettes and/or the paper(s) describing this package.

## Code of Conduct

Please note that the `megadepth` project is released with a [Contributor
Code of
Conduct](https://contributor-covenant.org/version/2/0/CODE_OF_CONDUCT.html).
By contributing to this project, you agree to abide by its terms.

## Development tools

- Continuous code testing is possible thanks to [GitHub
  actions](https://www.tidyverse.org/blog/2020/04/usethis-1-6-0/)
  through *[usethis](https://CRAN.R-project.org/package=usethis)*,
  *[remotes](https://CRAN.R-project.org/package=remotes)*,
  *[sysreqs](https://github.com/r-hub/sysreqs)* and
  *[rcmdcheck](https://CRAN.R-project.org/package=rcmdcheck)* customized
  to use [Bioconductor’s docker
  containers](https://www.bioconductor.org/help/docker/) and
  *[BiocCheck](https://bioconductor.org/packages/3.17/BiocCheck)*.
- Code coverage assessment is possible thanks to
  [codecov](https://codecov.io/gh) and
  *[covr](https://CRAN.R-project.org/package=covr)*.
- The [documentation
  website](http://LieberInstitute.github.io/megadepth) is automatically
  updated thanks to
  *[pkgdown](https://CRAN.R-project.org/package=pkgdown)*.
- The code is styled automatically thanks to
  *[styler](https://CRAN.R-project.org/package=styler)*.
- The documentation is formatted thanks to
  *[devtools](https://CRAN.R-project.org/package=devtools)* and
  *[roxygen2](https://CRAN.R-project.org/package=roxygen2)*.

For more details, check the `dev` directory.

This package was developed using
*[biocthis](https://bioconductor.org/packages/3.17/biocthis)*.

## `ReCount` project

The **main documentation website** for all the `recount3`-related
projects is available at
[**recount.bio**](https://LieberInstitute/github.io/recount3-docs).
Please check that website for more information about how this
R/Bioconductor package and other tools are related to each other.

## Teams involved

*[megadepth](https://bioconductor.org/packages/3.17/megadepth)* was made
possible to [David Zhang](https://twitter.com/dyzhang32), the author of
*[dasper](https://bioconductor.org/packages/3.17/dasper)*, and a member
of the [Mina Ryten](https://snca.atica.um.es/)’s lab at UCL.

The `ReCount` family involves the following teams:

- [Ben Langmead’s lab](http://www.langmead-lab.org/) at JHU Computer
  Science
- [Kasper Daniel Hansen’s lab](https://www.hansenlab.org/) at JHBSPH
  Biostatistics Department
- [Leonardo Collado-Torres](http://lcolladotor.github.io/) and
  [Andrew E. Jaffe](http://aejaffe.com/) from
  [LIBD](https://www.libd.org/)
- [Abhinav Nellore’s lab](http://nellore.bio/) at OHSU
- [Jeff Leek’s lab](http://jtleek.com/) at JHBSPH Biostatistics
  Deparment
- Data hosted by [SciServer from IDIES at
  JHU](https://www.sciserver.org/)

|                                                                                                                                                                               |                                                                                                              |                                                                                                                                                                         |                                                                                                                                                   |
|-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|--------------------------------------------------------------------------------------------------------------|-------------------------------------------------------------------------------------------------------------------------------------------------------------------------|---------------------------------------------------------------------------------------------------------------------------------------------------|
| <a href="http://www.langmead-lab.org/"><img src="http://www.langmead-lab.org/wp-content/uploads/2014/01/Screen-Shot-2014-02-02-at-5.20.13-PM-1024x199.png" width="250px"></a> | <a href="https://www.libd.org/"><img src="http://lcolladotor.github.io/img/LIBD_logo.jpg" width="250px"></a> | <a href="http://nellore.bio/"><img src="https://seekvectorlogo.net/wp-content/uploads/2018/08/oregon-health-science-university-ohsu-vector-logo.png" width="250px"></a> | <a href="https://www.sciserver.org/"><img src="https://skyserver.sdss.org/dr14/en/images/sciserver_logo_inverted_vertical.png" width="250px"></a> |

---
output: github_document
---

<!-- README.md is generated from README.Rmd. Please edit that file -->

```{r, include = FALSE}
knitr::opts_chunk$set(
    collapse = TRUE,
    comment = "#>",
    fig.path = "man/figures/README-",
    out.width = "100%"
)
```

# megadepth

<!-- badges: start -->
[![Lifecycle: stable](https://img.shields.io/badge/lifecycle-stable-brightgreen.svg)](https://lifecycle.r-lib.org/articles/stages.html#stable)
[![Bioc release status](http://www.bioconductor.org/shields/build/release/bioc/megadepth.svg)](https://bioconductor.org/checkResults/release/bioc-LATEST/megadepth)
[![Bioc devel status](http://www.bioconductor.org/shields/build/devel/bioc/megadepth.svg)](https://bioconductor.org/checkResults/devel/bioc-LATEST/megadepth)
[![Bioc downloads rank](https://bioconductor.org/shields/downloads/release/megadepth.svg)](http://bioconductor.org/packages/stats/bioc/megadepth/)
[![Bioc support](https://bioconductor.org/shields/posts/megadepth.svg)](https://support.bioconductor.org/tag/megadepth)
[![Bioc history](https://bioconductor.org/shields/years-in-bioc/megadepth.svg)](https://bioconductor.org/packages/release/bioc/html/megadepth.html#since)
[![Bioc last commit](https://bioconductor.org/shields/lastcommit/devel/bioc/megadepth.svg)](http://bioconductor.org/checkResults/devel/bioc-LATEST/megadepth/)
[![Bioc dependencies](https://bioconductor.org/shields/dependencies/release/megadepth.svg)](https://bioconductor.org/packages/release/bioc/html/megadepth.html#since)
[![Codecov test coverage](https://codecov.io/gh/LieberInstitute/megadepth/branch/devel/graph/badge.svg)](https://codecov.io/gh/LieberInstitute/megadepth?branch=devel)
[![R build status](https://github.com/LieberInstitute/megadepth/workflows/R-CMD-check-bioc/badge.svg)](https://github.com/LieberInstitute/megadepth/actions)
[![GitHub issues](https://img.shields.io/github/issues/LieberInstitute/megadepth)](https://github.com/LieberInstitute/megadepth/issues)
[![GitHub pulls](https://img.shields.io/github/issues-pr/LieberInstitute/megadepth)](https://github.com/LieberInstitute/megadepth/pulls)
<!-- badges: end -->

The goal of `megadepth` is to provide an R interface to the command line tool [Megadepth](https://github.com/ChristopherWilks/megadepth) for BigWig and BAM related utilities created by [Christopher Wilks](https://twitter.com/chrisnwilks). This R package enables **fast** processing of BigWig files on downstream packages such as [dasper](https://bioconductor.org/packages/dasper) and [recount3](https://bioconductor.org/packages/recount3). The [Megadepth](https://github.com/ChristopherWilks/megadepth) software also provides utilities for processing BAM files and extracting coverage information from them.

Here is an illustration on how fast `megadepth` is compared to other tools for processing local and remote BigWig files.

<a href="https://github.com/LieberInstitute/megadepth/tree/devel/analysis"><img src="https://raw.githubusercontent.com/LieberInstitute/megadepth/devel/analysis/md_rt_pybw_runtime.png" width="800px" ></a>

Throughout the documentation we use a capital `M` to refer to the software by Christopher Wilks and a lower case `m` to refer to this R/Bioconductor package.

## Installation instructions

Get the latest stable `R` release from [CRAN](http://cran.r-project.org/). Then install `megadepth` from [Bioconductor](http://bioconductor.org/) using the following code:

```{r 'install', eval = FALSE}
if (!requireNamespace("BiocManager", quietly = TRUE)) {
    install.packages("BiocManager")
}

BiocManager::install("megadepth")
```

And the development version from [GitHub](https://github.com/) with:

```{r 'install_dev', eval = FALSE}
BiocManager::install("LieberInstitute/megadepth")
```

## Example

In the following example, we install [Megadepth](https://github.com/ChristopherWilks/megadepth) with `install_megadepth()`, which downloads a binary for your OS (Linux, Windows or macOS). We can then use with an example BigWig file to compute the coverage at a set of regions.

```{r example, eval = requireNamespace('megadepth')}
## Load the R package
library("megadepth")

## Install Megadepth's pre-compiled binary on your system
install_megadepth()

## Next, we locate the example BigWig and annotation files
example_bw <- system.file("tests", "test.bam.all.bw",
    package = "megadepth", mustWork = TRUE
)
annotation_file <- system.file("tests", "testbw2.bed",
    package = "megadepth", mustWork = TRUE
)

## We can then use megadepth to compute the coverage
bw_cov <- get_coverage(example_bw, op = "mean", annotation = annotation_file)
bw_cov
```

## Full set of utilities

[Megadepth](https://github.com/ChristopherWilks/megadepth) is very powerful and can do a lot of different things. The R/Bioconductor package provides two functions for interfacing with [Megadepth](https://github.com/ChristopherWilks/megadepth), `megadepth_cmd()` and `megadepth_shell()`. For the first one, `megadepth_cmd()`, you need to know the actual command syntax you want to use and format it accordingly. If you are more comfortable with R functions, `megadepth_shell()` uses `r BiocStyle::CRANpkg("cmdfun")` to power this interface and capture the standard output stream into R.

To make it easier to use, `megadepth` includes functions that simplify the number of arguments, read in the output files, and converts them into R/Bioconductor friendly objects, such as `get_coverage()` illustrated above.

We hope that you'll find `megadepth` and [Megadepth](https://github.com/ChristopherWilks/megadepth) useful for your work. If you are interested in checking how **fast** `megadepth` is, check out the [**speed analysis**](https://github.com/LieberInstitute/megadepth/tree/devel/analysis) comparison against other tools. Note that the size of the files used and the number of genomic regions queried will affect the speed comparisons.

```{r "interface_options"}
## R-like interface
## that captures the standard output into R
head(megadepth_shell(help = TRUE))

## Command-like interface
megadepth_cmd("--help")
```

```{r "show_help", echo = FALSE}
x <- megadepth_shell(help = TRUE)
cat(paste0(x, "\n"))
```



## Citation

Below is the citation output from using `citation('megadepth')` in R. Please
run this yourself to check for any updates on how to cite __megadepth__.

```{r 'citation', eval = requireNamespace('megadepth')}
print(citation("megadepth"), bibtex = TRUE)
```

Please note that the `megadepth` was only made possible thanks to many other R and bioinformatics software authors, which are cited either in the vignettes and/or the paper(s) describing this package.

## Code of Conduct

Please note that the `megadepth` project is released with a [Contributor Code of Conduct](https://contributor-covenant.org/version/2/0/CODE_OF_CONDUCT.html). By contributing to this project, you agree to abide by its terms.

## Development tools

* Continuous code testing is possible thanks to [GitHub actions](https://www.tidyverse.org/blog/2020/04/usethis-1-6-0/)  through `r BiocStyle::CRANpkg('usethis')`, `r BiocStyle::CRANpkg('remotes')`, `r BiocStyle::Githubpkg('r-hub/sysreqs')` and `r BiocStyle::CRANpkg('rcmdcheck')` customized to use [Bioconductor's docker containers](https://www.bioconductor.org/help/docker/) and `r BiocStyle::Biocpkg('BiocCheck')`.
* Code coverage assessment is possible thanks to [codecov](https://codecov.io/gh) and `r BiocStyle::CRANpkg('covr')`.
* The [documentation website](http://LieberInstitute.github.io/megadepth) is automatically updated thanks to `r BiocStyle::CRANpkg('pkgdown')`.
* The code is styled automatically thanks to `r BiocStyle::CRANpkg('styler')`.
* The documentation is formatted thanks to `r BiocStyle::CRANpkg('devtools')` and `r BiocStyle::CRANpkg('roxygen2')`.

For more details, check the `dev` directory.

This package was developed using `r BiocStyle::Biocpkg('biocthis')`.

## `ReCount` project

The **main documentation website** for all the `recount3`-related projects is available at [**recount.bio**](https://LieberInstitute/github.io/recount3-docs). Please check that website for more information about how this R/Bioconductor package and other tools are related to each other.

## Teams involved

`r BiocStyle::Biocpkg('megadepth')` was made possible to [David Zhang](https://twitter.com/dyzhang32), the author of `r BiocStyle::Biocpkg("dasper")`, and a member of the [Mina Ryten](https://snca.atica.um.es/)'s lab at UCL.

The `ReCount` family involves the following teams:

* [Ben Langmead's lab](http://www.langmead-lab.org/) at JHU Computer Science
* [Kasper Daniel Hansen's lab](https://www.hansenlab.org/)  at JHBSPH Biostatistics Department
* [Leonardo Collado-Torres](http://lcolladotor.github.io/) and [Andrew E. Jaffe](http://aejaffe.com/) from [LIBD](https://www.libd.org/)
* [Abhinav Nellore's lab](http://nellore.bio/)  at OHSU
* [Jeff Leek's lab](http://jtleek.com/) at JHBSPH Biostatistics Deparment
* Data hosted by [SciServer from IDIES at JHU](https://www.sciserver.org/)

| | | | |
| --- | --- | --- | --- |
| <a href="http://www.langmead-lab.org/"><img src="http://www.langmead-lab.org/wp-content/uploads/2014/01/Screen-Shot-2014-02-02-at-5.20.13-PM-1024x199.png" width="250px"></a> | <a href="https://www.libd.org/"><img src="http://lcolladotor.github.io/img/LIBD_logo.jpg" width="250px"></a> | <a href="http://nellore.bio/"><img src="https://seekvectorlogo.net/wp-content/uploads/2018/08/oregon-health-science-university-ohsu-vector-logo.png" width="250px"></a> | <a href="https://www.sciserver.org/"><img src="https://skyserver.sdss.org/dr14/en/images/sciserver_logo_inverted_vertical.png" width="250px"></a> |

#' Run Megadepth commands
#'
#' Wrapper functions to run Megadepth commands via
#' \code{\link{system2}('megadepth', ...)}.
#'
#' @param ... Arguments to be passed to \code{system2('megadepth', ...)}, e.g.
#' \code{annotation(path)} is basically
#' \code{megadepth_cmd(c('--annotation', path))}
#' (i.e. run the command \command{megadepth --annotation path}).
#' @export
#' @return See `base::system2()` for the types of output you can generate.
#' @describeIn megadepth_cmd Run an arbitrary Megadepth command.
#'
#' @references
#' `megadepth_cmd()` is based on blogdown::hugo_cmd() which is available at
#' <https://github.com/rstudio/blogdown/blob/master/R/hugo.R>.
megadepth_cmd <- function(...) {
    system2(find_megadepth(), ...)
}

#' @param input A `character(1)` with the path to the input BAM, BigWig or
#' text file for Megadepth.
#' @export
#' @describeIn megadepth_cmd Run an arbitrary Megadepth command.
#'
#' @references
#' `megadepth_shell()` is based on the shell_ls() example from cmdfun which is
#' available at <https://snystrom.github.io/cmdfun/index.html>.
#'
#' @importFrom cmdfun cmd_args_dots cmd_list_interp cmd_list_to_flags
#' @return A `character()` with the capture of the standard output stream
#' generated by Megadepth.
#' @examples
#'
#' ## Install if necessary
#' install_megadepth()
#'
#' ## Find version
#' ## megadepth_shell() provides an interface more familiar to R users
#' megadepth_shell(version = TRUE)
#' ## megadepth_cmd() requires using directly the command line syntax for
#' ## Megadepth
#' megadepth_cmd("--version", stdout = TRUE)
#'
#' ## Compare the help files:
#' # megadepth_shell() captures the standard output and returns a character()
#' # megadepth_cmd() shows the standard output on the console
#' megadepth_shell("--help")
#' megadepth_cmd("--help")
megadepth_shell <- function(input = ".", ...) {
    # grab arguments passed to "..." in a list
    # prepare list for conversion to vector
    # Convert the list to a flag vector
    flags <- cmd_list_to_flags(cmd_list_interp(cmd_args_dots()),
        prefix = "--"
    )

    # Run ls shell command
    # system2(find_megadepth(), c(input, flags), stdout = TRUE)
    megadepth_cmd(c(input, flags), stdout = TRUE)
}

megadepth_shell2 <- function(input, theArgs) {
    # prepare list for conversion to vector
    # Convert the list to a flag vector
    flags <- cmd_list_to_flags(cmd_list_interp(theArgs),
        prefix = "--"
    )

    # Run ls shell command
    # system2(find_megadepth(), c(input, flags), stdout = TRUE)
    megadepth_cmd(c(input, flags), stdout = TRUE)
}

## test bigwig2mean
test_that("test bigwig2mean", {
    megadepth_shell(
        pkg_file("tests", "test.bam.all.bw"),
        "op" = "mean",
        "annotation" = pkg_file("tests", "testbw2.bed"),
        "prefix" = file.path(tempdir(), "bw2.mean"),
        "no-annotation-stdout" = TRUE
    )

    expect_equal(
        readLines(file.path(
            tempdir(), "bw2.mean.annotation.tsv"
        )),
        readLines(
            "https://raw.githubusercontent.com/ChristopherWilks/megadepth/master/tests/testbw2.bed.mean"
        )
    )
    expect_equal(
        read_coverage(file.path(
            tempdir(), "bw2.mean.annotation.tsv"
        )),
        get_coverage(
            pkg_file("tests", "test.bam.all.bw"),
            op = "mean",
            annotation = pkg_file("tests", "testbw2.bed"),
            prefix = file.path(tempdir(), "bw2.mean.r")
        )
    )
})

## Run test to obtain junctions from a BAM file
test_that("test bam_to_junctions has correct output", {
    bam_to_junctions(pkg_file("tests", "test2.bam"),
        overwrite = TRUE,
        all_junctions = TRUE,
        junctions = TRUE
    )

    expect_equal(
        readLines(file.path(tempdir(), "test2.bam.jxs.tsv")),
        readLines(
            "https://raw.githubusercontent.com/ChristopherWilks/megadepth/master/tests/test2.bam.jxs.tsv"
        )
    )

    expect_equal(
        readLines(file.path(tempdir(), "test2.bam.all_jxs.tsv")),
        readLines(
            "https://raw.githubusercontent.com/ChristopherWilks/megadepth/master/tests/test2.bam.all_jxs.tsv"
        )
    )

    expect_error(
        bam_to_junctions(pkg_file("tests", "test2.bam")),
        "The following files already exist"
    )

    # test changing filter_in/filter_out will remove junctions
    bam_to_junctions(pkg_file("tests", "test2.bam"),
        overwrite = TRUE,
        all_junctions = TRUE,
        junctions = TRUE,
        filter_in = 65536
    )

    expect_equal(
        length(readLines(file.path(tempdir(), "test2.bam.jxs.tsv"))),
        0
    )

    bam_to_junctions(pkg_file("tests", "test2.bam"),
        overwrite = TRUE,
        all_junctions = TRUE,
        junctions = TRUE,
        filter_out = 261
    )

    expect_equal(
        length(readLines(file.path(tempdir(), "test2.bam.jxs.tsv"))),
        0
    )
})

## test long reads support for junctions
test_that("test long reads support for junctions", {
    megadepth_shell(
        pkg_file("tests", "long_reads.bam"),
        "junctions" = TRUE,
        "all_junctions" = FALSE,
        "prefix" = file.path(tempdir(), "long_reads.bam"),
        "long-reads" = TRUE
    )

    bam_to_junctions(
        pkg_file("tests", "long_reads.bam"),
        overwrite = TRUE,
        junctions = TRUE,
        all_junctions = FALSE,
        prefix = file.path(tempdir(), "long_reads.bam.r"),
        long_reads = TRUE
    )

    expect_equal(
        readLines(file.path(tempdir(), "long_reads.bam.jxs.tsv")),
        readLines(
            "https://raw.githubusercontent.com/ChristopherWilks/megadepth/master/tests/long_reads.bam.jxs.tsv"
        )
    )

    expect_equal(
        readLines(file.path(tempdir(), "long_reads.bam.jxs.tsv")),
        readLines(file.path(
            tempdir(), "long_reads.bam.r.jxs.tsv"
        ))
    )
})

# Based on tests at https://github.com/ChristopherWilks/megadepth/blob/master/tests/test.sh

## Create test files
if (!xfun::is_windows()) {
    ## This currently fails on Windows
    megadepth_shell(
        pkg_file("tests", "test.bam"),
        "prefix" = file.path(tempdir(), "test.bam"),
        "threads" = 1,
        "bigwig" = TRUE,
        "auc" = TRUE,
        "min-unique-qual" = 10,
        "annotation" = pkg_file("tests", "test_exons.bed"),
        "frag-dist" = TRUE,
        "alts" = TRUE,
        "include-softclip" = TRUE,
        "only-polya" = TRUE,
        "read-ends" = TRUE,
        "test-polya" = TRUE,
        "no-annotation-stdout" = TRUE
    )
} else {
    ## Copy the test files
    test_files <-
        dir(pkg_file("tests", "test_output_files"),
            "test.bam",
            full.names = TRUE
        )
    sapply(test_files, file.copy, tempdir())
}

## Run AUC test
total_auc <-
    megadepth_shell(file.path(tempdir(), "test.bam.all.bw"))
test_that("test just total auc", {
    expect_equal(
        total_auc[length(total_auc)],
        readLines(
            "https://raw.githubusercontent.com/ChristopherWilks/megadepth/master/tests/testbw1.total_auc"
        )
    )
})

## test with uniques
test_that("test with uniques", {
    megadepth_shell(
        pkg_file("tests", "test3.bam"),
        "coverage" = TRUE,
        "min-unique-qual" = 10,
        "bigwig" = TRUE,
        "auc" = TRUE,
        "prefix" = file.path(tempdir(), "test3"),
        "no-auc-stdout" = TRUE
    )
    expect_equal(
        readLines(file.path(tempdir(), "test3.auc.tsv")),
        readLines(
            "https://raw.githubusercontent.com/ChristopherWilks/megadepth/master/tests/test3.auc.out.tsv"
        )
    )
})


## test bigwig2mean on remote BW
test_that("test bigwig2mean on remote bw", {
    megadepth_shell(
        "https://snaptron.cs.jhu.edu/data/temp/megadepth.test.bam.all.bw",
        "op" = "mean",
        "annotation" = pkg_file("tests", "testbw2.bed"),
        "prefix" = file.path(tempdir(), "bw2.remote.mean"),
        "no-annotation-stdout" = TRUE
    )

    expect_equal(
        readLines(file.path(
            tempdir(), "bw2.remote.mean.annotation.tsv"
        )),
        readLines(
            "https://raw.githubusercontent.com/ChristopherWilks/megadepth/master/tests/testbw2.bed.mean"
        )
    )
})

## only print sums use different order in BED file from what's in BW to test keep_order == true
test_that("test bigwig2mean on local bw", {
    megadepth_shell(
        file.path(tempdir(), "test.bam.all.bw"),
        "--sums-only" = TRUE,
        "annotation" = pkg_file("tests", "testbw2.bed"),
        "prefix" = file.path(tempdir(), "test.bam.bw2"),
        "no-annotation-stdout" = TRUE
    )


    expect_equal(
        readLines(file.path(
            tempdir(), "test.bam.bw2.annotation.tsv"
        )),
        readLines(
            "https://raw.githubusercontent.com/ChristopherWilks/megadepth/master/tests/testbw2.bed.out.tsv"
        )
    )
})

#' Extract junctions from a BAM file
#'
#' Given a BAM file, extract junction information including co-ordinates,
#' strand, anchor length for each junction read. For details on the format of
#' the output TSV file, check
#' <https://github.com/ChristopherWilks/megadepth#junctions>.
#'
#' @inheritParams bam_to_bigwig
#'
#' @param prefix A `character(1)` specifying the output file prefix. This
#' function creates a file called `prefix.jxs.tsv`. By default, the prefix is
#' the BAM file name and the file is created in the `tempdir()` and will be
#' deleted after you close your R session.
#' @param all_junctions A `logical(1)` indicating whether to obtain all
#'   junctions.
#' @param junctions A `logical(1)` indicating whether to obtain co-occurring jx
#'   coordinates.
#' @param long_reads A `logical(1)` indicating whether to increase the buffer
#'   size to accommodate for long-read RNA-sequencing.
#' @param filter_in A `integer(1)` used to filter in read alignments. See
#'   https://github.com/ChristopherWilks/megadepth#bamcram-processing and
#'   https://samtools.github.io/hts-specs/SAMv1.pdf for further documentation on
#'   how to apply this parameter.
#' @param filter_out A `integer(1)` used to filter out read alignments. See
#'   https://github.com/ChristopherWilks/megadepth#bamcram-processing and
#'   https://samtools.github.io/hts-specs/SAMv1.pdf for further documentation on
#'   how to apply this parameter.
#'
#' @return A `character(1)` with the path to the output junction tsv file.
#'
#' @export
#'
#' @examples
#'
#' ## Install if necessary
#' install_megadepth()
#'
#' ## Find the example BAM file
#' example_bam <- system.file("tests", "test.bam",
#'     package = "megadepth", mustWork = TRUE
#' )
#'
#' ## Run bam_to_junctions()
#' example_jxs <- bam_to_junctions(example_bam, overwrite = TRUE)
#'
#' ## Path to the output file generated by bam_to_junctions()
#' example_jxs
bam_to_junctions <- function(
        bam_file,
        prefix = file.path(tempdir(), basename(bam_file)),
        all_junctions = TRUE,
        junctions = FALSE,
        long_reads = FALSE,
        filter_in = 65535,
        filter_out = 260,
        overwrite = FALSE) {
    expected_ext <- c("all_jxs.tsv", "jxs.tsv")
    if (!overwrite) prefix_exists(prefix, expected_ext)

    megadepth_shell2(
        bam_file,
        list(
            "prefix" = prefix,
            "junctions" = junctions,
            "all-junctions" = all_junctions,
            "long-reads" = long_reads,
            "filter-in" = filter_in,
            "filter-out" = filter_out
        )
    )

    ## Find the prefix files
    new_files <- prefix_files(prefix)
    ## List only those that match the expected file names
    new_files <- new_files[names(new_files) %in% expected_ext]

    return(new_files)
}

test_that("read_junction_table has correct output", {
    example_bam <- system.file("tests",
        "test2.bam",
        package = "megadepth",
        mustWork = TRUE
    )

    example_jxs <- bam_to_junctions(example_bam, overwrite = TRUE, junctions = TRUE)
    all_jxs <- read_junction_table(example_jxs[["all_jxs.tsv"]])

    expect_equal(
        all_jxs,
        read_junction_table(
            "https://raw.githubusercontent.com/ChristopherWilks/megadepth/master/tests/test2.bam.all_jxs.tsv"
        )
    )

    suppressWarnings(expr = {
        jxs <- read_junction_table(example_jxs[["jxs.tsv"]])
        chris_jxs <- read_junction_table(
            "https://raw.githubusercontent.com/ChristopherWilks/megadepth/master/tests/test2.bam.jxs.tsv"
        )
    })

    # remove the "problems" attribute
    # which stores the warning that some rows have 7 cols
    # this differs between the two objects as path to the files are different
    attr(jxs, "problems") <- NULL
    attr(chris_jxs, "problems") <- NULL

    expect_equal(jxs, chris_jxs)
})

## ----setup, include = FALSE---------------------------------------------------
knitr::opts_chunk$set(
    collapse = TRUE,
    comment = "#>",
    crop = NULL ## Related to https://stat.ethz.ch/pipermail/bioc-devel/2020-April/016656.html
)

## ----vignetteSetup, echo=FALSE, message=FALSE, warning = FALSE----------------
## Track time spent on making the vignette
startTime <- Sys.time()

## Bib setup
library("RefManageR")

## Write bibliography information
bib <- c(
    R = citation(),
    BiocStyle = citation("BiocStyle")[1],
    knitr = citation("knitr")[1],
    rmarkdown = citation("rmarkdown")[1],
    sessioninfo = citation("sessioninfo")[1],
    testthat = citation("testthat")[1],
    megadepth = citation("megadepth")[1],
    megadepthpaper = citation("megadepth")[2],
    bioconductor2015 = RefManageR::BibEntry(
        bibtype = "Article",
        key = "bioconductor2015",
        author = "Wolfgang Huber and Vincent J Carey and Robert Gentleman and Simon Anders and Marc Carlson and Benilton S Carvalho and Hector Corrada Bravo and Sean Davis and Laurent Gatto and Thomas Girke and Raphael Gottardo and Florian Hahne and Kasper D Hansen and Rafael A Irizarry and Michael Lawrence and Michael I Love and James MacDonald and Valerie Obenchain and Andrzej K Oleś and Hervé Pagès and Alejandro Reyes and Paul Shannon and Gordon K Smyth and Dan Tenenbaum and Levi Waldron and Martin Morgan",
        title = "Orchestrating high-throughput genomic analysis with Bioconductor",
        year = 2015, doi = "10.1038/nmeth.3252",
        journal = "Nature Methods",
        journaltitle = "Nat Methods"
    ),
    RefManageR = citation("RefManageR")[1],
    rtracklayer = citation("rtracklayer")
)

## ----"runtime", out.width="100%", echo = FALSE, fig.cap = "Timing results. Timing comparison for processing 1,000 genomic regions on a bigWig file that is available on the local disk or on a remote resource. We compared megadepth against rtracklayer and pyBigWig. megadepth is typically faster that these other software solutions for computing the mean coverage across a set of 1,000 input genomic regions. Check <https://github.com/LieberInstitute/megadepth/tree/devel/analysis> for more details."----
knitr::include_graphics("https://raw.githubusercontent.com/LieberInstitute/megadepth/devel/analysis/md_rt_pybw_runtime.png")

## ----"install", eval = FALSE--------------------------------------------------
#  if (!requireNamespace("BiocManager", quietly = TRUE)) {
#      install.packages("BiocManager")
#  }
#  
#  BiocManager::install("megadepth")
#  
#  ## Check that you have a valid Bioconductor installation
#  BiocManager::valid()

## ----"citation"---------------------------------------------------------------
## Citation info
citation("megadepth")

## ----"start", message=FALSE---------------------------------------------------
library("megadepth")

## ----"install_software"-------------------------------------------------------
## Install the latest version of Megadepth
install_megadepth(force = TRUE)

## ----"locate_example_bw"------------------------------------------------------
## Next, we locate the example BigWig and annotation files
example_bw <- system.file("tests", "test.bam.all.bw",
    package = "megadepth", mustWork = TRUE
)
annotation_file <- system.file("tests", "testbw2.bed",
    package = "megadepth", mustWork = TRUE
)

## Where are they?
example_bw
annotation_file

## ----example------------------------------------------------------------------
## We can then use megadepth to compute the coverage
bw_cov <- get_coverage(
    example_bw,
    op = "mean",
    annotation = annotation_file
)
bw_cov

## ----"interface_options"------------------------------------------------------
## R-like interface
## that captures the standard output into R
head(megadepth_shell(help = TRUE))

## Command-like interface
megadepth_cmd("--help")

## ----"show_help", echo = FALSE------------------------------------------------
x <- megadepth_shell(help = TRUE)
cat(paste0(x, "\n"))

## ----"bam_to_bigwig", eval = !xfun::is_windows()------------------------------
## Find the example BAM file
example_bam <- system.file("tests", "test.bam",
    package = "megadepth", mustWork = TRUE
)

## Create the BigWig file
## Currently Megadepth does not support this on Windows
example_bw <- bam_to_bigwig(example_bam, overwrite = TRUE)

## Path to the output files generated by bam_to_bigwig()
example_bw

## ----"bam_to_bigwig_windows", eval = xfun::is_windows()-----------------------
#  ## On Windows, use the example bigWig file that is already included in
#  ## the R package
#  example_bw <- system.file("tests", "test.bam.all.bw",
#      package = "megadepth", mustWork = TRUE
#  )

## ----"get_coverage"-----------------------------------------------------------
## Next, we locate the example annotation BED file
annotation_file <- system.file("tests", "testbw2.bed",
    package = "megadepth", mustWork = TRUE
)

## Now we can compute the coverage
bw_cov <- get_coverage(example_bw, op = "mean", annotation = annotation_file)
bw_cov

## ----"rtracklayer_derfinder"--------------------------------------------------
## Checking with derfinder and rtracklayer
bed <- rtracklayer::import(annotation_file)

## The file needs a name
names(example_bw) <- "example"

## Read in the base-pair coverage data
regionCov <- derfinder::getRegionCoverage(
    regions = bed,
    files = example_bw,
    verbose = FALSE
)

## Summarize the base-pair coverage data.
## Note that we have to round the mean to make them comparable.
testthat::expect_equivalent(
    round(sapply(regionCov[c(1, 3:4, 2)], function(x) mean(x$value)), 2),
    bw_cov$score,
)

## If we compute the sum, there's no need to round
testthat::expect_equivalent(
    sapply(regionCov[c(1, 3:4, 2)], function(x) sum(x$value)),
    get_coverage(example_bw, op = "sum", annotation = annotation_file)$score,
)

## ----"bam_to_junctions"-------------------------------------------------------
## Find the example BAM file
example_bam <- system.file("tests", "test.bam",
    package = "megadepth", mustWork = TRUE
)

## Run bam_to_junctions()
example_jxs <- bam_to_junctions(example_bam, overwrite = TRUE)

## Path to the output file generated by bam_to_junctions()
example_jxs

## Read the data as a tibble using the format specified at
## https://github.com/ChristopherWilks/megadepth#megadepth-pathtobamfile---junctions
example_jxs <- read_junction_table(example_jxs)

example_jxs

process_junction_table(example_jxs)

## ----createVignette, eval=FALSE-----------------------------------------------
#  ## Create the vignette
#  library("rmarkdown")
#  system.time(render("megadepth.Rmd", "BiocStyle::html_document"))
#  
#  ## Extract the R code
#  library("knitr")
#  knit("megadepth.Rmd", tangle = TRUE)

## ----reproduce1, echo=FALSE---------------------------------------------------
## Date the vignette was generated
Sys.time()

## ----reproduce2, echo=FALSE---------------------------------------------------
## Processing time in seconds
totalTime <- diff(c(startTime, Sys.time()))
round(totalTime, digits = 3)

## ----reproduce3, echo=FALSE-------------------------------------------------------------------------------------------
## Session info
library("sessioninfo")
options(width = 120)
session_info()

## ----vignetteBiblio, results = "asis", echo = FALSE, warning = FALSE, message = FALSE---------------------------------
## Print bibliography
PrintBibliography(bib, .opts = list(hyperlink = "to.doc", style = "html"))

#' Install Megadepth
#'
#' Download the appropriate Megadepth executable for your platform from Github
#' and try to copy it to a system directory so \pkg{megadepth} can run the
#' \command{megadepth} command.
#'
#' If this function is run in an non-interactive session such as \code{R CMD
#' Check}, it will install Megadepth to \code{tempdir()}. If this function is
#' run interactively, the user will be prompted to agree to allow Megadepth to
#' be installed at \code{Sys.getenv('APPDATA')} on Windows,
#' \file{~/Library/Application Support} on macOS, and \file{~/bin/} on other
#' platforms (such as Linux). If these directories are not writable, the package
#' directory \file{Megadepth} of \pkg{megadepth} will be used. If it still
#' fails, you have to install Megadepth by yourself and make sure it can be
#' found via the environment variable \code{PATH}.
#'
#' If you want to install Megadepth to a custom path, you can set the global
#' option \code{megadepth.dir} to a directory to store the Megadepth executable
#' before you call \code{install_megadepth()}, e.g.,
#' \code{options(megadepth.hugo.dir = '~/Downloads/Megadepth_1.0.4/')}.
#' This may be useful for you to use a specific
#' version of Megadepth for a specific project. You can set this option per
#' project, similar to how \code{blogdown.hugo.dir} is used for specifying
#' the directory for Hugo in the \pkg{blogdown} package..
#' See \href{https://bookdown.org/yihui/blogdown/global-options.html}{Section
#' 1.4 Global options} for details, or store a copy of Megadepth on a USB Flash
#' drive along with your project code.
#'
#' @param version A `character(`)` specifying the Megadepth version number,
#' e.g., \code{1.0.4}; the special value \code{latest} means the latest version
#' (fetched from Github releases).
#' @param force A `logical(1)` specifying whether to install megadepth even if
#' it has already been installed.
#'
#' @importFrom xfun is_windows is_macos same_path
#' @importFrom utils download.file file_test
#' @importFrom fs dir_exists
#' @export
#' @return Returns `NULL`. The main use is to install Megadepth.
#' @references
#' This function is based on blogdown::install_hugo() which is available from
#' <https://github.com/rstudio/blogdown/blob/master/R/install.R>.
#'
#' @examples
#'
#' ## Install megadepth
#' install_megadepth()
install_megadepth <- function(version = "latest", force = FALSE) {
    if (Sys.which("megadepth") != "" && !force) {
        message("It seems megadepth has been installed. Use force = TRUE to reinstall or upgrade.")
        return(invisible())
    }

    if (version == "latest") {
        version <- megadepth_latest()
        message("The latest megadepth version is ", version)
    }

    base <- sprintf(
        "https://github.com/ChristopherWilks/megadepth/releases/download/%s/",
        version
    )

    exec_ext <- if (xfun::is_windows()) {
        ".exe"
    } else if (xfun::is_macos()) {
        "_macos"
    } else {
        ""
    }

    url <- paste0(base, "megadepth", exec_ext)
    exec_name <-
        ifelse(xfun::is_windows(), "megadepth.exe", "megadepth")
    exec <- file.path(tempdir(), exec_name)

    utils::download.file(url,
        destfile = exec,
        quiet = TRUE,
        mode = "wb"
    )

    if (!xfun::is_windows()) {
        Sys.chmod(exec, "0755")
    }

    if (interactive()) {
        install_megadepth_bin(exec)
    } else {
        message(
            "This is not an interactive session, ",
            "therefore megadepth has been installed temporarily to \n",
            exec
        )
    }
}

megadepth_latest <- function() {
    h <- readLines("https://github.com/ChristopherWilks/megadepth/releases/latest",
        warn = FALSE
    )
    r <- '^.*?releases/tag/([0-9.]+[a-z]?)".*'
    version <- gsub(r, "\\1", grep(r, h, value = TRUE)[1])
    return(version)
}

install_megadepth_bin <- function(exec) {
    success <- FALSE
    dirs <- bin_paths()

    message(
        "megadepth will be be installed at ",
        "one of the following directories.\n",
        "Directories will be tried in sequential order until megadepth is succesffuly installed, ",
        "or no directories remain:\n",
        paste(dirs, collapse = ", "),
        "\nWould you like to proceed?"
    )

    do_it <- utils::menu(c("Yes", "No")) == 1

    if (!do_it) {
        return(invisible())
    }

    for (destdir in dirs) {
        dir.create(destdir, showWarnings = FALSE)
        success <- file.copy(exec, destdir, overwrite = TRUE)
        if (success) {
            break
        }
    }
    if (!success) {
        stop(
            "Unable to install megadepth to any of these dirs: ",
            paste(dirs, collapse = ", ")
        )
    }
    message("megadepth has been installed to ", normalizePath(destdir))
}

# obtain possible locations of the megadepth executable
bin_paths <- function(
        dir = "Megadepth",
        extra_path = getOption("megadepth.dir")) {
    if (xfun::is_windows()) {
        path <- Sys.getenv("APPDATA", "")
        path <- if (fs::dir_exists(path)) {
            file.path(path, dir)
        }
    } else if (xfun::is_macos()) {
        path <- "~/Library/Application Support"
        path <- if (fs::dir_exists(path)) file.path(path, dir)
        path <- c("/usr/local/bin", path)
    } else {
        path <- c("~/bin", "/snap/bin", "/var/lib/snapd/snap/bin")
    }
    path <- c(extra_path, path, pkg_file(dir, mustWork = FALSE))
    # remove empty paths potentially created by pkgfile
    path <- path[path != ""]
    # if not interactive, look for megadepth in the tempdir() for find_exec()
    if (!interactive()) {
        path <- c(tempdir(), path)
    }
    path
}

# find an executable from PATH, APPDATA, system.file(), ~/bin, etc
find_exec <- function(cmd, dir, info = "") {
    for (d in bin_paths(dir)) {
        exec <- if (xfun::is_windows()) {
            paste0(cmd, ".exe")
        } else {
            cmd
        }
        path <- file.path(d, exec)
        if (utils::file_test("-x", path)) {
            break
        } else {
            path <- ""
        }
    }
    path2 <- Sys.which(cmd)
    if (path == "" || xfun::same_path(path, path2)) {
        if (path2 == "") {
            stop(cmd, " not found. ", info, call. = FALSE)
        }
        return(cmd) # do not use the full path of the command
    } else {
        if (path2 != "") {
            warning(
                "Found ",
                cmd,
                ' at "',
                path,
                '" and "',
                path2,
                '". The former will be used. ',
                "If you don't need both copies, you may delete/uninstall one."
            )
        }
    }
    normalizePath(path)
}

find_megadepth <- local({
    path <- NULL # cache the path to megadepth
    function() {
        if (is.null(path)) {
            path <<- find_exec(
                cmd = "megadepth",
                dir = "Megadepth",
                info = "You can install it via megadepth::install_megadepth()"
            )
        }
        path
    }
})

test_that("installation of the latest version works", {
    expect_message(
        megadepth::install_megadepth(force = TRUE),
        "megadepth has been installed"
    )
    expect_equal(
        find_exec("megadepth", "Megadepth"),
        find_megadepth()
    )
    expect_true(
        grepl(
            pattern = megadepth_cmd("--version", stdout = TRUE),
            paste("megadepth", megadepth_latest())
        )
    )
    expect_equal(
        megadepth_cmd("--version", stdout = TRUE),
        megadepth_shell(version = TRUE)
    )
})

# Solve "no visible binding for global variable 'chr'... etc" issue
# https://www.r-bloggers.com/2019/08/no-visible-binding-for-global-variable/
utils::globalVariables(c(
    "chr",
    "start",
    "end",
    "strand",
    "read_name",
    "n_reads",
    "uniquely_mapping_reads",
    "intron_motif",
    "annotated",
    "multimapping_reads"
))

#' Read a junction TSV file created by Megadepth as a table
#'
#' Read an `*all_jxs.tsv` or `*jxs.tsv` file created by `bam_to_junctions()` or
#' manually by the user using Megadepth. The rows of a `*jxs.tsv` can have
#' either 7 or 14 columns, which can lead to warnings when reading in - these
#' are safe to ignore. For details on the format of the input TSV file, check
#' <https://github.com/ChristopherWilks/megadepth#junctions>.
#'
#' @param tsv_file A `character(1)` specifying the path to the tab-separated
#'   (TSV) file created manually using `megadepth_shell()` or on a previous
#'   `bam_to_junctions()` run.
#'
#' @importFrom readr read_delim
#' @return A `tibble::tibble()` with the junction data that follows the format
#'   specified at <https://github.com/ChristopherWilks/megadepth#junctions>.
#' @export
#'
#' @examples
#'
#' ## Install if necessary
#' install_megadepth()
#'
#' ## Find the example BAM file
#' example_bam <- system.file("tests", "test.bam",
#'     package = "megadepth", mustWork = TRUE
#' )
#'
#' ## Run bam_to_junctions()
#' example_jxs <- bam_to_junctions(example_bam, overwrite = TRUE)
#'
#' ## Read the junctions in as a tibble
#' all_jxs <- read_junction_table(example_jxs[["all_jxs.tsv"]])
#'
#' all_jxs
read_junction_table <- function(tsv_file) {
    # define the expected column names and types
    if (grepl("all_jxs.tsv", tsv_file)) {
        col_names <- c(
            "read_name",
            "chr",
            "start",
            "end",
            "mapping_strand",
            "cigar",
            "unique"
        )

        col_types <- c("ccddici")
    } else if (grepl("jxs.tsv", tsv_file)) {
        col_names <- c(
            "chr_id",
            "POS_field",
            "mapping_strand",
            "insert_length",
            "cigar",
            "junction_coords",
            "unique",
            "mate_ref_id",
            "mate_POS_field",
            "mate_mapping_strand",
            "mate_insert_length",
            "mate_cigar",
            "mate_junction_coords",
            "mate_unique"
        )

        col_types <- c("ciidcciciidcci")
    } else {
        stop('tsv_file must have the extension "all_jxs.tsv" or "jxs.tsv"')
    }

    # load in the junctions
    jxs <- readr::read_delim(
        tsv_file,
        delim = "\t",
        progress = FALSE,
        col_names = col_names,
        col_types = col_types
    )

    ## Translate the strand into the format used in Bioconductor
    for (i in seq_along(jxs)) {
        if (grepl("strand", colnames(jxs[i]))) {
            jxs[[i]] <- ifelse(jxs[[i]] == 0, "+", "-")
        }
    }

    return(jxs)
}

#' Process junctions into a STAR compatible format
#'
#' Parses the junctions outputted from `process_junction_table()` into an STAR
#' compatible format (SJ.out) for more convenient use in downstream analyses.
#' The columns strand, intron_motif and annotated will always be 0 (undefined)
#' but can be derived through extracting the dinucleotide motifs for the given
#' reference coordinates for canonical motifs. This function is an
#' R-implementation of the Megadepth helper script, on which further details of
#' column definitions can be found:
#' <https://github.com/ChristopherWilks/megadepth#junctions>.
#'
#' @param all_jxs A `tibble::tibble()` containing junction data ("all.jxs.tsv")
#'   generated by `bam_to_junctions(all_junctions = TRUE)` and imported through
#'   `megadepth::read_junction_table()`.
#'
#' @importFrom magrittr %>%
#' @importFrom dplyr arrange group_by summarise mutate select
#' @return Processed junctions in a STAR-compatible format.
#'
#' @export
#'
#' @examples
#'
#' ## Install if necessary
#' install_megadepth()
#'
#' ## Find the example BAM file
#' example_bam <- system.file("tests", "test.bam",
#'     package = "megadepth", mustWork = TRUE
#' )
#'
#' ## Run bam_to_junctions()
#' example_jxs <- bam_to_junctions(example_bam, overwrite = TRUE)
#'
#' ## Read the junctions in as a tibble
#' all_jxs <- read_junction_table(example_jxs[["all_jxs.tsv"]])
#'
#' ## Process junctions into a STAR-compatible format
#' processed_jxs <- process_junction_table(all_jxs)
#'
#' processed_jxs
process_junction_table <- function(all_jxs) {
    colnames_exp <- c(
        "read_name",
        "chr",
        "start",
        "end",
        "mapping_strand",
        "cigar",
        "unique"
    )

    colnames_act <- colnames(all_jxs)

    if (!identical(colnames_exp, colnames_act)) {
        stop(paste(
            "all_jxs argument should have colnames:",
            paste(colnames_exp, collapse = ", "),
            "\nHave junctions from a jxs.tsv been used instead of a all_jxs.tsv?"
        ))
    }

    processed_jxs <- all_jxs %>%
        dplyr::arrange(chr, start, end, read_name) %>%
        dplyr::distinct(chr, start, end, read_name, .keep_all = TRUE) %>%
        dplyr::group_by(chr, start, end) %>%
        dplyr::summarise(
            uniquely_mapping_reads = sum(unique),
            n_reads = dplyr::n(),
            .groups = "drop"
        ) %>%
        dplyr::mutate(
            multimapping_reads = n_reads - uniquely_mapping_reads,
            strand = 0,
            intron_motif = 0,
            annotated = 0
        ) %>%
        dplyr::select(
            chr,
            start,
            end,
            strand,
            intron_motif,
            annotated,
            uniquely_mapping_reads,
            multimapping_reads
        )

    return(processed_jxs)
}

example_bam <- system.file("tests",
    "test2.bam",
    package = "megadepth",
    mustWork = TRUE
)

example_jxs <- bam_to_junctions(example_bam,
    all_junctions = TRUE,
    junctions = TRUE,
    overwrite = TRUE
)

all_jxs <- read_junction_table(example_jxs[["all_jxs.tsv"]])

##### read_junction_table #####

test_that("read_junction_table has correct output", {
    expect_equal(
        all_jxs,
        read_junction_table(
            "https://raw.githubusercontent.com/ChristopherWilks/megadepth/master/tests/test2.bam.all_jxs.tsv"
        )
    )

    suppressWarnings(expr = {
        jxs <- read_junction_table(example_jxs[["jxs.tsv"]])
        chris_jxs <- read_junction_table(
            "https://raw.githubusercontent.com/ChristopherWilks/megadepth/master/tests/test2.bam.jxs.tsv"
        )
    })

    expect_equal(jxs, chris_jxs, ignore_attr = TRUE)
})

test_that("read_junction_table catches user input errors", {
    expect_error(
        read_junction_table(tsv_file = "no_correct_extension"),
        'tsv_file must have the extension "all_jxs.tsv" or "jxs.tsv"'
    )
})

##### process_junction_table ######

# Don't test on windows as needs to download and run .sh script
if (!xfun::is_windows()) {
    # download Chris' script for testing
    process_jx_script_path <- file.path(tempdir(), "process_jx_output.sh")

    download.file(
        "https://raw.githubusercontent.com/ChristopherWilks/megadepth/master/junctions/process_jx_output.sh",
        process_jx_script_path
    )

    Sys.chmod(process_jx_script_path, "0755")

    # wrap using process_jx_output.sh in function
    process_jx_output_shell <- function(all_jxs_path, process_jx_script_path) {
        system(paste(
            process_jx_script_path,
            all_jxs_path
        ))

        # processed junctions
        processed_jxs <- readr::read_delim(
            paste0(all_jxs_path, ".sjout"),
            delim = "\t",
            col_names = c(
                "chr",
                "start",
                "end",
                "strand",
                "intron_motif",
                "annotated",
                "uniquely_mapping_reads",
                "multimapping_reads",
                "X9"
            )
        ) %>% dplyr::select(-X9)

        return(processed_jxs)
    }

    test_that("process_junction_table has correct output", {
        # also read/test junctions from test.bam (as well as test2.bam above)
        example_bam2 <- system.file("tests",
            "test.bam",
            package = "megadepth",
            mustWork = TRUE
        )

        example_jxs2 <- bam_to_junctions(example_bam2,
            all_junctions = TRUE,
            junctions = TRUE,
            overwrite = TRUE
        )

        suppressWarnings(expr = {
            processed_jxs2_shell <- process_jx_output_shell(
                all_jxs_path = example_jxs2[["all_jxs.tsv"]],
                process_jx_script_path
            )
        })

        suppressWarnings(expr = {
            processed_jxs_shell <- process_jx_output_shell(
                all_jxs_path = example_jxs[["all_jxs.tsv"]],
                process_jx_script_path
            )
        })

        # ignore_attr = TRUE is needed as there are "spec" and "problems"
        # attributes that are created on the tibble through read_delim()
        expect_equal(process_junction_table(all_jxs),
            processed_jxs_shell,
            ignore_attr = TRUE
        )

        expect_equal(
            example_jxs2[["all_jxs.tsv"]] %>%
                read_junction_table() %>%
                process_junction_table(),
            processed_jxs2_shell,
            ignore_attr = TRUE
        )
    })
}

test_that("process_junction_table catches user input errors", {
    suppressWarnings(expr = {
        jxs <- read_junction_table(example_jxs[["jxs.tsv"]])
    })

    expect_error(
        process_junction_table(jxs),
        "all_jxs argument should have colnames"
    )
})

# use local full-size bam for testing
# avoid testing when local bam is not available, to avoid large test times
# in which case, unit testing relies on using test.bam/test2.bam above
bam_path <- "/data/RNA_seq_diag/niccolo_X_linked_dystonia/180420-140039/STAR/NIAA_Aligned.sortedBysamtools.out.bam"

if (file.exists(bam_path)) {
    local_bam_jxs <- bam_to_junctions(bam_path,
        all_junctions = TRUE,
        overwrite = TRUE
    )

    # take first n_rows_to_test rows
    n_rows_to_test <- 1000000
    local_bam_jxs_head <- local_bam_jxs[["all_jxs.tsv"]] %>%
        gsub(".all_jxs", "_head.all_jxs", .)

    local_bam_jxs[["all_jxs.tsv"]] %>%
        readr::read_delim(
            n_max = n_rows_to_test,
            col_names = FALSE,
            delim = "\t"
        ) %>%
        readr::write_delim(local_bam_jxs_head,
            col_names = FALSE,
            delim = "\t"
        )

    local_bam_jxs_processed <- read_junction_table(local_bam_jxs_head) %>%
        process_junction_table()

    suppressWarnings(
        local_bam_jxs_processed_shell <-
            process_jx_output_shell(
                local_bam_jxs_head,
                process_jx_script_path
            )
    )

    test_that("process_junction_table works on a larger set of jxs", {
        expect_equal(local_bam_jxs_processed,
            local_bam_jxs_processed_shell,
            ignore_attr = TRUE
        )
    })
}

## Helper function for locating prefix files
prefix_files <- function(prefix) {
    files_found <- dir(
        dirname(prefix),
        pattern = paste0("^", basename(prefix)),
        full.names = TRUE
    )
    ## Set the names if we found any files
    if (length(files_found) > 0) {
        names(files_found) <- gsub(
            paste0("^", basename(prefix), "\\."),
            "",
            basename(files_found)
        )
    }
    return(files_found)
}

## Helper function for checking if the files exist already
prefix_exists <- function(prefix, expected_ext) {
    expected_files <- paste0(prefix, ".", expected_ext)
    files_present <- file.exists(expected_files)
    if (any(files_present)) {
        stop(
            "The following files already exist.\n",
            "Use overwrite = TRUE to replace them. Existing file(s):\n",
            paste(expected_files[files_present], collapse = "\n"),
            call. = FALSE
        )
    }
}

#' Read a coverage TSV file created by Megadepth
#'
#' Read an `*annotation.tsv` file created by `get_coverage()` or manually by
#' the user using Megadepth.
#'
#' @param tsv_file A `character(1)` specifying the path to the tab-separated
#' (TSV) file created manually using `megadepth_shell()` or on a previous
#' `get_coverage()` run.
#' @param verbose A `logical(1)` controlling whether to suppress messages when
#' reading the data.
#'
#' @return A [GRanges-class][GenomicRanges::GRanges-class] object with the
#' coverage summarization across the annotation ranges.
#' @export
#' @family Coverage functions
#' @importFrom GenomicRanges GRanges
#' @importFrom readr read_delim cols
#'
#' @examples
#'
#' ## Install if necessary
#' install_megadepth()
#'
#' ## Locate example BigWig and annotation files
#' example_bw <- system.file("tests", "test.bam.all.bw",
#'     package = "megadepth", mustWork = TRUE
#' )
#' annotation_file <- system.file("tests", "testbw2.bed",
#'     package = "megadepth", mustWork = TRUE
#' )
#'
#' ## Compute the coverage
#' bw_cov <- get_coverage(example_bw, op = "mean", annotation = annotation_file)
#' bw_cov
#'
#' ## Read in the coverage file again, using read_coverage()
#' ## First, lets locate the tsv file that was generated by get_coverage()
#' tsv_file <- file.path(tempdir(), "bw.mean.annotation.tsv")
#' bw_cov_manual <- read_coverage(tsv_file)
#' stopifnot(identical(bw_cov, bw_cov_manual))
#'
#' ## To get an RleList object, just like the one you would get
#' ## from using rtracklayer::import.bw(as = "RleList") directly on the
#' ## BigWig file, use:
#' GenomicRanges::coverage(bw_cov_manual)
#'
#' ## The coverage data can also be read as a `tibble::tibble()`
#' read_coverage_table(tsv_file)
read_coverage <- function(tsv_file, verbose = TRUE) {
    if (verbose) {
        coverage <- read_coverage_table(tsv_file)
    } else {
        suppressMessages(coverage <- read_coverage_table(tsv_file))
    }

    ## Cast into a GRanges object
    coverage <- GenomicRanges::GRanges(coverage)

    return(coverage)
}


#' @describeIn read_coverage Read a coverage TSV file created by Megadepth as
#' a table
#'
#' @return A `tibble::tibble()` with columns `chr`, `start`, `end` and `score`.
#' @export
read_coverage_table <- function(tsv_file) {
    coverage <- readr::read_delim(
        tsv_file,
        delim = "\t",
        col_names = c("chr", "start", "end", "score"),
        col_types = readr::cols(
            chr = "c",
            start = "i",
            end = "i",
            score = "n"
        ),
        progress = FALSE
    )
    return(coverage)
}

#' Compute coverage summarizations across a set of regions
#'
#' Given an input set of annotation regions, compute coverage summarizations
#' using Megadepth for a given BigWig file.
#'
#' Note that the chromosome names (seqnames) in the BigWig file and the
#' annotation file should use the same format. Otherwise, Megadepth will
#' return 0 counts.
#'
#' @param bigwig_file A `character(1)` with the path to the input BigWig file.
#' @param op A `character(1)` specifying the summarization operation to
#' perform.
#' @param annotation A `character(1)` path to a BED file with the genomic
#' coordinates you are interested in.
#' @param prefix A `character(1)` specifying the output file prefix. This
#' function creates a file called `prefix.annotation.tsv` that can be read
#' again later with `read_coverage()`. By default the file is created in
#' the `tempdir()` and will be deleted after you close your R session.
#'
#' @return A [GRanges-class][GenomicRanges::GRanges-class] object with the
#' coverage summarization across the annotation ranges.
#' @export
#' @family Coverage functions
#'
#' @examples
#'
#' ## Install if necessary
#' install_megadepth()
#'
#' ## Next, we locate the example BigWig and annotation files
#' example_bw <- system.file("tests", "test.bam.all.bw",
#'     package = "megadepth", mustWork = TRUE
#' )
#' annotation_file <- system.file("tests", "testbw2.bed",
#'     package = "megadepth", mustWork = TRUE
#' )
#'
#' ## Compute the coverage
#' bw_cov <- get_coverage(example_bw, op = "mean", annotation = annotation_file)
#' bw_cov
#'
#' ## If you want to cast this into a RleList object use the following code:
#' ## (it's equivalent to rtracklayer::import.bw(as = "RleList"))
#' ## although in the megadepth case the data has been summarized
#' GenomicRanges::coverage(bw_cov)
#'
#' ## Checking with derfinder and rtracklayer
#' bed <- rtracklayer::import(annotation_file)
#'
#' ## The file needs a name
#' names(example_bw) <- "example"
#'
#' ## Read in the base-pair coverage data
#' if (!xfun::is_windows()) {
#'     regionCov <- derfinder::getRegionCoverage(
#'         regions = bed,
#'         files = example_bw,
#'         verbose = FALSE
#'     )
#'
#'     ## Summarize the base-pair coverage data.
#'     ## Note that we have to round the mean to make them comparable.
#'     testthat::expect_equivalent(
#'         round(sapply(regionCov[c(1, 3:4, 2)], function(x) mean(x$value)), 2),
#'         bw_cov$score,
#'     )
#'
#'     ## If we compute the sum, there's no need to round
#'     testthat::expect_equivalent(
#'         sapply(regionCov[c(1, 3:4, 2)], function(x) sum(x$value)),
#'         get_coverage(example_bw, op = "sum", annotation = annotation_file)$score,
#'     )
#' }
get_coverage <-
    function(
        bigwig_file,
        op = c("sum", "mean", "max", "min"),
        annotation,
        prefix = file.path(tempdir(), "bw.mean")) {
        megadepth_shell2(
            bigwig_file,
            list(
                "op" = match.arg(op),
                "annotation" = annotation,
                "prefix" = prefix,
                "no-annotation-stdout" = TRUE
            )
        )
        read_coverage(paste0(prefix, ".annotation.tsv"))
    }

#' Convert a BAM file to a BigWig
#'
#' Given an input BAM file, convert this to the BigWig format which can then be
#' used in `get_coverage()`.
#'
#' Note that this functionality is currently not supported on Windows by
#' Megadepth.
#'
#' @param bam_file A `character(1)` with the path to the input BAM file.
#' @param prefix A `character(1)` specifying the output file prefix. This
#'   function creates a BigWig file called `{prefix}.all.bw`. By default, the
#'   prefix is the BAM file name and the file is created in the `tempdir()` and
#'   will be deleted after you close your R session.
#' @param min_unique_qual A `integer(1)` specifying a mapping quality threshold
#'   and only bases above this will be used to generate the BigWig. If set to
#'   `FALSE` this argument is not used by Megadepth. Otherwise it will generate
#'   files `{prefix}.unique.bw` and `{prefix}.unique.tsv`.
#' @param double_count A `logical(1)` determining whether to count the
#'   overlapping ends of paired ends reads twice.
#' @param overwrite A `logical(1)` specifying whether to overwrite the output
#' file(s), if they exist already.
#'
#' @return A `character()` with the path to the output files(s).
#' @export
#'
#' @examples
#'
#' ## Install the latest version if necessary
#' install_megadepth(force = TRUE)
#'
#' ## Find the example BAM file
#' example_bam <- system.file("tests", "test.bam",
#'     package = "megadepth", mustWork = TRUE
#' )
#'
#' ## Create the BigWig file
#' ## Currently Megadepth does not support this on Windows
#' if (!xfun::is_windows()) {
#'     example_bw <- bam_to_bigwig(example_bam, overwrite = TRUE)
#'
#'     ## Path to the output file(s) generated by bam_to_bigwig()
#'     example_bw
#'
#'     ## Use the all.bw file in get_coverage(), first find an annotation file
#'     annotation_file <- system.file("tests", "testbw2.bed",
#'         package = "megadepth", mustWork = TRUE
#'     )
#'
#'     ## Compute the coverage
#'     bw_cov <- get_coverage(
#'         example_bw["all.bw"],
#'         op = "mean",
#'         annotation = annotation_file
#'     )
#'     bw_cov
#' }
bam_to_bigwig <- function(
        bam_file,
        prefix = file.path(tempdir(), basename(bam_file)),
        min_unique_qual = FALSE,
        double_count = FALSE,
        overwrite = FALSE) {
    if (xfun::is_windows()) {
        warning(
            "Megadepth currently does not support creating bigWig files on ",
            "Windows. This function will still try to run the code, as a ",
            "newer version of Megadepth might support this feature. Please ",
            "let us know if code works for you on Windows! Thanks!",
            call. = FALSE
        )
    }

    ## Hm.. the unique.tsv file is empty with the current example data
    ## even with min_unique_qual = 0
    expected_ext <- c("all.bw", "unique.bw", "unique.tsv")
    if (!overwrite) prefix_exists(prefix, expected_ext)

    megadepth_shell2(
        bam_file,
        list(
            "prefix" = prefix,
            "bigwig" = TRUE,
            "min-unique-qual" = min_unique_qual,
            "double-count" = double_count
        )
    )

    ## Find the prefix files
    new_files <- prefix_files(prefix)
    ## List only those that match the expected file names
    new_files <- new_files[names(new_files) %in% expected_ext]

    return(new_files)
}

## test conversion of BAM to BigWig
if (!xfun::is_windows()) {
    test_that("test conversion of BAM to bw", {
        ## Create the bigwig file
        new_files <- bam_to_bigwig(
            pkg_file("tests", "test.bam"),
            overwrite = TRUE
        )

        ## Check the md5sum
        expect_equal(
            unname(tools::md5sum(new_files["all.bw"])),
            unname(tools::md5sum(pkg_file("tests", "test.bam.all.bw")))
        )
        expect_error(
            bam_to_bigwig(pkg_file("tests", "test.bam")),
            "The following files already exist"
        )
    })
}

#!/usr/bin/env bash

set -ex

platform=$1

target_dir=libBigWig

#in case we're not using git submodules to pull dependencies
if [[ -z $SUBMODULE ]]; then
    if [[ -n $platform ]]; then
        target_dir="libBigWig_"${platform}
    fi
    VER=0.4.4
    TARGZ=${VER}.tar.gz
    FN=libBigWig-${TARGZ}
    DIR=libBigWig-${VER}
    curl -L https://github.com/dpryan79/libBigWig/archive/${TARGZ} > $FN
    tar -zxvf $FN
    rm -f ${FN}
    mv $DIR $target_dir
fi

pushd $target_dir

cp Makefile Makefile.orig
cat Makefile.orig | perl -ne 'chomp; $f=$_; $f=~s/^(CFLAGS.+)$/$1 -DNOCURL/; $f=~s/^(LIBS =.*)(-lcurl)/$1/; $f=~s/^(LDFLAGS.+)=/$1\?=/; print "$f\n";' > Makefile.nocurl
cat Makefile.orig | perl -ne 'chomp; $f=$_; $f=~s/^(CFLAGS \?= )$/$1 -fPIC /; $f=~s/^(LDFLAGS.+)=/$1\?=/; print "$f\n";' > Makefile.fpic
popd

#!/usr/bin/env bash
set -xe

sdir=$(dirname $0)

mkdir -p paste
mkdir -p runs

/bin/bash -x ${sdir}/find_new_files.sh ./sums srav3h.ids.all.final.tsv ./paste all .tsv > find.run 2>&1 &

ls paste/all.??.??.manifest | perl -ne 'chomp; print "'${sdir}'/remove_extra_samples.sh $_\n";' > remove_extra_samples.jobs
/bin/bash -x remove_extra_samples.randoms100.jobs

cut -f 1-2 srav3h.ids.all.final.tsv | perl -ne 'chomp; ($study,$run)=split(/\t/,$_); $study=~/(..)$/; $s=$1; $run=~/(..)$/; $r=$1; print "/bin/bash -x '${sdir}'/group_sums.sh paste/all.$s.$r.manifest paste/all.$s.$r.grouped convert_to_int > runs/all.$s.$r.grouped.run 2>&1\n";' | sort -u > group_sums.u.jobs
/usr/bin/time -v parallel -j 33 < group_sums.u.jobs > group_sums.u.jobs.run 2>&1

cut -f 1-2 srav3h.ids.all.final.tsv | perl -ne 'chomp; ($study,$run)=split(/\t/,$_); $study=~/(..)$/; $s=$1; $run=~/(..)$/; $r=$1; print "/bin/bash -x '${sdir}'/paste_sums.sh paste/all.$s.$r.manifest paste/all.$s.$r.pasted 0 > runs/all.$s.$r.pasted.run 2>&1\n";' | sort -u > paste_sums_per_group.u.jobs
/usr/bin/time -v parallel -j33 < paste_sums_per_group.u.jobs > paste_sums_per_group.u.jobs.run 2>&1

cut -f 1-2 srav3h.ids.all.final.tsv | perl -ne 'chomp; ($study,$run)=split(/\t/,$_); $study=~/(..)$/; $s=$1; $run=~/(..)$/; $r=$1; print "$s\t$r\n";' | sort -u | perl -ne 'chomp;  ($s,$r)=split(/\t/,$_); print "ls paste/all.$s.??.pasted > paste/all.$s.pasted.files.list\n";' | sort -u > ls.paste.u.jobs
/bin/bash -x ls.paste.jobs.u > ls.paste.jobs.u.run 2>&1

ls paste/*.list | perl -ne 'chomp; $f=$_; $f=~/all\.(..)\.pasted\.files\.list/; $s=$1; print "/bin/bash -x '${sdir}'/paste_sums.sh $f paste/all.$s.pasted 0 dont_get_ids > runs/all.$s.pasted.run 2>&1\n";' | sort -u > paste_sums_per_study_group.u.jobs
/usr/bin/time -v parallel -j33 < paste_sums_per_study_group.u.jobs > paste_sums_per_study_group.u.jobs.run 2>&1

ls paste/all.??.pasted > paste/all.groups.pasted.files.list 

/usr/bin/time -v /bin/bash -x ${sdir}/paste_sums.sh paste/all.groups.pasted.files.list all.samples.pasted.gz 8 dont_get_ids ryten.random.bed

#!/usr/bin/env bash

set -e

if [[ ! -d /code ]] ; then
    echo "Must mount megadepth directory at /code inside container"
fi 
cd /code

rm -rf htslib libBigWig
./get_htslib.sh
./get_libBigWig.sh

set -x

DR=build-release-temp
mkdir -p ${DR}
pushd ${DR}
cmake -DCMAKE_BUILD_TYPE=Release ..
make
ldd -v megadepth
./megadepth --help
popd
cp ${DR}/megadepth ./megadepth
rm -rf ${DR}

DR=build-debug-temp
mkdir -p ${DR}
pushd ${DR}
cmake -DCMAKE_BUILD_TYPE=Debug ..
make
ldd -v megadepth
./megadepth --help
popd
cp ${DR}/megadepth ./megadepth-debug
rm -rf ${DR}

zip megadepth.zip megadepth megadepth-debug
#rm -f megadepth megadepth-debug

#!/usr/bin/env bash
set -x -o pipefail -o errexit -o nounset
#this will produce a sorted, STAR-compatible formatted file of splice junction calls from BAM processed with Megadepth --all-junctions
#unlike STAR:
#1) splice junction strand is *not* determined (always 0 in column 4)
#2) splice junction motifs are *not* determineda (always 0 in column 5)
#both of these can be determined by extracting the dinucleotide motifs for the given reference coordinates for canonical motifs

#input format:
#read_name, chrom, start(1-based), end, strand_of_alignment (or actual strand if XS:A tag present), CIGAR, is_uniqe_alignment(1/0)
jx_file=$1

#for faster sorting
export LC_ALL=C
#sort & format for compatibility unifier using STAR's SJ.out file format:
#chromosome  1based_intron_start 1based_intron_end   strand_0:undefined,1:+,2:-  intron_motif:0:non-canonical;1:GT/AG,2:CT/AC,3:GC/AG,4:CT/GC,5:AT/AC,6:GT/AT    0:unannotated,1:annotated_in_spliceDB   #uniquely_mapping_reads #multi_mapping_reads    maximum_spliced_alignment_overhang
#this determines maximum_spliced_alignment_overhang via STAR's method as described here (last post by Dobin):
#https://groups.google.com/g/rna-star/c/XN0cWBxVFcM/m/ywcUg_s3CQAJ
#for now, we leave blank the last column from STAR, which is the maximum of the min anchors for each junction, this requires more info than megadepth emits at this time (2021/01)
sort -k2,2 -k3,3n -k4,4n -k1,1 -u $jx_file | cut -f 1,2-4,6,7 | perl -ne 'chomp; ($qname,$c,$s,$e,$cigar,$is_unique)=split(/\t/,$_); if($pc) { if($s == $ps && $e == $pe) { if($is_unique == 1) { $ucnt++; } else { $cnt++; } next; } else { print "$pc\t$ps\t$pe\t0\t0\t0\t$ucnt\t$cnt\t\n"; }} $ucnt=0; $cnt=0; if($is_unique == 1) { $ucnt=1; } else { $cnt=1; } $pc=$c; $ps=$s; $pe=$e; END { if($pc) { print "$pc\t$ps\t$pe\t0\t0\t0\t$ucnt\t$cnt\t\n"; }}' > ${jx_file}.sjout
#new way, using XS:A strand determination if present, not yet ready
#sort -k2,2 -k3,3n -k4,4n -k1,1 -u $jx_file | perl -ne 'chomp; ($qname,$c,$s,$e,$orient,$cigar,$is_unique)=split(/\t/,$_); if($pc) { if($s == $ps && $e == $pe && $o eq $po) { if($is_unique == 1) { $ucnt++; } else { $cnt++; } next; } else { print "$pc\t$ps\t$pe\t$po\t0\t0\t$ucnt\t$cnt\t\n"; }} $ucnt=0; $cnt=0; if($is_unique == 1) { $ucnt=1; } else { $cnt=1; } $pc=$c; $ps=$s; $pe=$e; $po=0; if($orient ne "0" && $orient ne "1") { $po=$orient eq "+"?1:2; } END { if($pc) { print "$pc\t$ps\t$pe\t$po\t0\t0\t$ucnt\t$cnt\t\n"; }}' > ${jx_file}.sjout

#!/bin/bash -x
set -o pipefail -o nounset -o errexit 

manifest=$1
output_sentinel=$2
convert_to_int=$3
#run one group job at a time, but run it for all of the files listed in the manifest
if [[ -n $convert_to_int ]]; then
    #cut -f 3 $manifest | xargs -n 1 -P 1 -I{} sh -c 'cut -f 4 $1 | sed "s/\.0*$//" > ${1}.unc' -- {}
    cut -f 3 $manifest | xargs -n 1 -P 1 -I{} sh -c 'cat $1 | sed "s/\.0*$//" > ${1}.unc' -- {}
else
    #cut -f 3 $manifest | xargs -n 1 -P 1 -I{} sh -c 'cut -f 4 $1 > ${1}.unc' -- {}
    cut -f 3 $manifest | xargs -n 1 -P 1 -I{} sh -c 'cat $1 $1 > ${1}.unc' -- {}
fi
cut -f 3 $manifest | perl -ne 'chomp; $f=$_.".unc"; @s=stat($f); if($s[7]==0) { `cp blank_exon_sums $f`;}'
#when done, write a "done" sentinel
touch $output_sentinel

#!/bin/bash
set -o pipefail -o errexit 

manifest=$1
output=$2
threads=$3
dont_get_ids=$4
existing_sums=$5
#[optional] number of threads to use when pigz'ing output, default 4
if [[ -z $threads ]]; then
	threads=1
fi

if [ -n "$dont_get_ids" ]; then
#if set, we're doing a final paste of all previously pasted (or copied) sample groups so no need to handle sample IDs
    #for debugging, dont delete pasted intermediates
    cat $manifest | perl -ne 'chomp; $f=$_; $s.=" $f"; $c++; END { if($c > 1) { print "paste $s\n"; `paste $s > '${output}'`; } else { `cat $f > '${output}'`; }}'
    #cat $manifest | perl -ne 'chomp; $f=$_; $s.=" $f"; $c++; END { if($c > 1) { print "paste $s\n"; `paste $s > '${output}'`; `rm $s`; } else { `cat $f > '${output}'`; }}'
    #cat $manifest | perl -ne 'chomp; $f=$_; $s.=" $f"; $c++; END { if($c > 1) { print "paste $s\n"; `paste $s > '${output}'`; `rm $s`; } else { `cat $f > '${output}'`; `rm $f`; }}'
else
#here we need to make sure we output the correct order of samples IDs as the column header
#acc_header is an env var
#optional flag to switch to accessions instad of rail_ids as the header
    if [[ -z $acc_header ]]; then
    	cut -f 2,3 $manifest | perl -ne 'chomp; ($rid,$f)=split(/\t/,$_); $h.="$rid\t"; $s.=" $f.unc"; $c++; END { $h=~s/\t$//; open(OUT,">'${output}'"); print OUT "$h\n"; close(OUT); if($c > 1) { print "paste $s\n"; `paste $s >> '${output}'`; } else { `cat $f.unc >> '${output}'`;  }}'
    	#cut -f 2,3 $manifest | perl -ne 'chomp; ($rid,$f)=split(/\t/,$_); $h.="$rid\t"; $s.=" $f.unc"; $c++; END { $h=~s/\t$//; open(OUT,">'${output}'"); print OUT "$h\n"; close(OUT); if($c > 1) { print "paste $s\n"; `paste $s >> '${output}'`; `rm $s`; } else { `cat $f.unc >> '${output}'`; `rm $f.unc`; }}'
    else
    	cut -f 3,4 $manifest | perl -ne 'chomp; ($f,$rid)=split(/\t/,$_); $h.="$rid\t"; $s.=" $f.unc"; $c++; END { $h=~s/\t$//; open(OUT,">'${output}'"); print OUT "$h\n"; close(OUT); if($c > 1) { print "paste $s\n"; `paste $s >> '${output}'`; } else { `cat $f.unc >> '${output}'`; }}'
    	#cut -f 3,4 $manifest | perl -ne 'chomp; ($f,$rid)=split(/\t/,$_); $h.="$rid\t"; $s.=" $f.unc"; $c++; END { $h=~s/\t$//; open(OUT,">'${output}'"); print OUT "$h\n"; close(OUT); if($c > 1) { print "paste $s\n"; `paste $s >> '${output}'`; `rm $s`; } else { `cat $f.unc >> '${output}'`; `rm $f.unc`; }}'
    fi
fi


if [ -n "$existing_sums" ]; then
    mv ${output} ${output}.pre_existing
    if [[ $threads -eq 0 ]]; then
        #assumes if we dont want to compress the output then the intermediate input is no compressed either
        paste ${existing_sums} ${output}.pre_existing > ${output}
    else
        paste ${existing_sums} ${output}.pre_existing | pigz --fast -p $threads > ${output}
    fi
fi

#!/usr/bin/env bash

set -ex
#yum install cmake -yy

working_dir=$(dirname $0)
pushd $working_dir

#clear symlink main lib dirs
rm -rf zlib htslib libBigWig libdeflate build-release-temp

export PATH=/opt/rh/devtoolset-8/root/usr/bin:$PATH
export CFLAGS="-g -O2 -fvisibility=hidden -DCURL_STATICLIB -fPIC"
export CPPFLAGS="-g -O2 -fvisibility=hidden -I/hbb_shlib/include"
export LDFLAGS="-L/hbb_shlib/lib -static-libstdc++"
export SHLIB_LDFLAGS="-static-libstdc++"
export STATICLIB_CFLAGS="-g -O2 -fvisibility=hidden -fPIC"
export STATICLIB_CPPFLAGS="-g -O2 -fvisibility=hidden -I/hbb_shlib/include"

build_type=$1
bc=`perl -e '$bt="'$build_type'"; if($bt=~/static/i) { print "megadepth_static"; } else { print "megadepth"; }'`

if [[ "$bc" == "megadepth_static" ]]; then
    ln -fs CMakeLists.txt.static CMakeLists.txt
else
    ln -fs CMakeLists.txt.statlib CMakeLists.txt
fi

#dont need our own zlib, since it's already statically compiled in HBB

if [[ ! -s libdeflate_hbb ]] ; then
    ./get_libdeflate.sh
    mv libdeflate libdeflate_hbb
fi
ln -fs libdeflate_hbb libdeflate

if [[ ! -s htslib_hbb ]] ; then
    export CPPFLAGS="$CPPFLAGS -I../libdeflate"
    #for staticlly linking libcurl
    export LDFLAGS="-static-libstdc++ -L/hbb_shlib/lib -L../libdeflate"
    export LIBS="-lm -ldl -lssl -lcrypto -lz -ldeflate -lrt -pthread"
    ./get_htslib.sh linux hbb
    export CPPFLAGS="-g -O2 -fvisibility=hidden -I/hbb_shlib/include"
    export LDFLAGS="-L/hbb_shlib/lib -static-libstdc++"
    export LIBS=
    #reset env vars
    mv htslib htslib_hbb
fi
ln -fs htslib_hbb htslib

if [[ ! -s libBigWig_hbb ]] ; then
    ./get_libBigWig.sh
    pushd libBigWig
    export CFLAGS="-O2 -I/hbb_shlib/include -DCURL_STATICLIB -fPIC"
    make clean
    make -f Makefile.fpic lib-static
    popd
    mv libBigWig libBigWig_hbb
fi
ln -fs libBigWig_hbb libBigWig
export CFLAGS="-g -O2 -fvisibility=hidden -I/hbb_shlib/include -DCURL_STATICLIB -fPIC"
export LDFLAGS="-L/hbb_shlib/lib -static-libstdc++"

set -x

export LD_LIBRARY_PATH=./htslib:./libBigWig:$LD_LIBRARY_PATH

DR=build-release-temp
mkdir -p ${DR}
pushd ${DR}
cmake -DCMAKE_BUILD_TYPE=Release ..
make ${bc}
popd
cp ${DR}/${bc} ./
#ln -fs ./$bc megadepth
./megadepth --version
rm -rf ${DR}
mv megadepth megadepth.full
strip -s megadepth.full -o megadepth

DR=build-debug-temp
mkdir -p ${DR}
pushd ${DR}
cmake -DCMAKE_BUILD_TYPE=Debug ..
make ${bc}
popd
cp ${DR}/${bc} ./${bc}_hbb_debug
#ln -fs ./${bc}_debug megadepth_debug
./megadepth_hbb_debug --version
rm -rf ${DR}

ln -fs ./megadepth_hbb_debug mddebug

#!/usr/bin/env bash

set -ex

VER=1.2.11
if [[ -z $SUBMODULE ]]; then
    ar=zlib-${VER}.tar.gz
    wget https://www.zlib.net/${ar}
    gzip -dc ${ar} | tar xvf - 
    rm -f ${ar}
    pushd zlib-${VER}
else 
    pushd zlib
fi
./configure
make
popd
if [[ -z $SUBMODULE ]]; then
    mv zlib-${VER} zlib
fi

#!/usr/bin/env bash
#build "statlib" version (or main linux version) of megadepth
./run_hbb_build_container.sh
./run_macos_build_container.sh
./run_windows_build_container.sh
#build latest Docker runner image:
/bin/bash -x create_docker_to_run_megadepth.sh

#!/usr/bin/env bash

set -ex

#build dynamic by default
build_type=$1
bc=`perl -e '$bt="'$build_type'"; if($bt=~/static/i) { print "megadepth_static"; } else { print "megadepth_dynamic"; }'`

#make sure submodules are present
git submodule update --init --recursive
export SUBMODULE=1

ln -fs CMakeLists.txt.ci CMakeLists.txt

#clear symlink main lib dirs
rm -rf zlib htslib libBigWig libdeflate build-release-temp

if [[ -n $build_type && "$build_type" == "static" ]] ; then
    if [[ ! -s zlib_ci/libz.a ]] ; then
        if [[ -n $SUBMODULE ]]; then
            ln -fs zlib_ci zlib
        fi
        ./get_zlib.sh
        if [[ -z $SUBMODULE ]]; then
            mv zlib zlib_ci
        fi
    fi
    ln -fs zlib_ci zlib
fi

if [[ ! -s libdeflate_ci/libdeflate.a ]] ; then
    if [[ -n $SUBMODULE ]]; then
        ln -fs libdeflate_ci libdeflate
    fi
    ./get_libdeflate.sh
    if [[ -z $SUBMODULE ]]; then
        mv libdeflate libdeflate_ci
    fi
fi
ln -fs libdeflate_ci libdeflate

htslib_to_link="htslib_ci"
if [[ -n $build_type && "$build_type" == "static" ]]; then
    htslib_to_link="htslib_static"
fi

if [[ ! -s htslib_ci/libhts.so && "$htslib_to_link" != "htslib_static" ]] || 
    [[ ! -s htslib_static/libhts.a && "$htslib_to_link" == "htslib_static" ]]; then
    export CPPFLAGS="-I../libdeflate"
    export LDFLAGS="-L../libdeflate -ldeflate"
    if [[ "$htslib_to_link" == "htslib_static" ]]; then
        ./get_htslib.sh linux static
    else
        if [[ -n $SUBMODULE ]]; then
            ln -fs htslib_ci htslib
        fi
        ./get_htslib.sh linux
        if [[ -z $SUBMODULE ]]; then
            mv htslib htslib_ci
        fi
    fi
    export CPPFLAGS=
    export LDFLAGS=
fi
ln -fs $htslib_to_link htslib

if [[ ! -s libBigWig_ci/libBigWig.so ]] ; then
    if [[ -n $SUBMODULE ]]; then
        ln -fs libBigWig_ci libBigWig
    fi
    ./get_libBigWig.sh
    if [[ -z $SUBMODULE ]]; then
        mv libBigWig libBigWig_ci
    fi
    pushd libBigWig_ci
    make clean
    make -f Makefile.orig lib-shared
    popd
fi
ln -fs libBigWig_ci libBigWig

#compile a no-curl static version of libBigWig
if [[ $bc == 'megadepth_static' ]]; then
    pushd libBigWig
    make clean
    make -f Makefile.nocurl lib-static
    popd
fi

export LD_LIBRARY_PATH=./htslib:./libBigWig:$LD_LIBRARY_PATH

DR=build-release-temp
mkdir -p ${DR}
pushd ${DR}
cmake -DCMAKE_BUILD_TYPE=Release ..
make ${bc}
popd
cp ${DR}/${bc} ./megadepth_release
./megadepth --version
rm -rf ${DR}

DR=build-debug-temp
mkdir -p ${DR}
pushd ${DR}
cmake -DCMAKE_BUILD_TYPE=Debug ..
make ${bc}
popd
cp ${DR}/${bc} ./megadepth_debug
./megadepthd --version
rm -rf ${DR}

#docker run --ulimit core=-1 -it --volume `pwd`:/build:rw --entrypoint=/bin/bash osxcross_gcc -i
docker run --ulimit core=-1 -it --volume `pwd`:/build:rw --entrypoint=/build/build_no_container_macos.sh osxcross_gcc -i

#!/usr/bin/env bash

set -ex
bc=megadepth_static

working_dir=$(dirname $0)
pushd $working_dir

ln -fs CMakeLists.txt.windows CMakeLists.txt

#clear symlink main lib dirs
rm -rf zlib htslib libBigWig libdeflate libcurl build-release-temp

#.e.g x86_64-w64-mingw32 or i686-w64-mingw32
compiler=x86_64-w64-mingw32
#e.g. 64 (32 doesn't work at this point)
arch=64
export CC=${compiler}-gcc
export CXX=${compiler}-g++
export AR=${compiler}-ar
export RANLIB=${compiler}-ranlib

if [[ ! -s mingw-std-threads ]]; then
    git clone https://github.com/meganz/mingw-std-threads.git
fi

CURL_VER=7.71.1
ARCH=$arch #32 #64 as of 2020-07-31, 32bit doesn't work due to recv not being linked properly in 32bit mingw libws2_32
if [[ ! -s libcurl_windows ]] ; then
    for f in curl-${CURL_VER}-win${ARCH}-mingw.zip libssh2-1.9.0-win${ARCH}-mingw.zip openssl-1.1.1g-win${ARCH}-mingw.zip nghttp2-1.41.0-win${ARCH}-mingw.zip brotli-1.0.7-win${ARCH}-mingw.zip zlib-1.2.11-win${ARCH}-mingw.zip; do
        wget  "https://curl.haxx.se/windows/dl-${CURL_VER}/${f}" -O $f
        unzip $f
    done
    ln -fs curl-${CURL_VER}-win${ARCH}-mingw libcurl_windows
    ln -fs libssh2-1.9.0-win${ARCH}-mingw libssh2
    ln -fs openssl-1.1.1g-win${ARCH}-mingw openssl
    ln -fs nghttp2-1.41.0-win${ARCH}-mingw nghttp2
    ln -fs brotli-1.0.7-win${ARCH}-mingw brotli
    ln -fs zlib-1.2.11-win${ARCH}-mingw zlib_windows
fi

if [[ ! -s libdeflate_windows ]] ; then
    ./get_libdeflate.sh $compiler windows
fi

if [[ ! -s htslib_windows ]] ; then
    export CFLAGS="-I../libdeflate_windows -I../zlib_windows"
    export LDFLAGS="-L../libdeflate_windows -L../zlib_windows -lz -ldeflate"
    
    ./get_htslib.sh $compiler windows 

    export CFLAGS=
    export LDFLAGS=
fi

if [[ ! -s libBigWig_windows ]] ; then
    ./get_libBigWig.sh windows
    pushd libBigWig_windows
    export CFLAGS="-I../libcurl_windows/include -I../zlib_windows -g -Wall -O3 -Wsign-compare -DCURL_STATICLIB"
    make clean
    make CC=${compiler}-gcc AR=$AR RANLIB=$RANLIB -f Makefile.fpic lib-static
    export CFLAGS=
    popd
fi

set -x

DR=build-release-temp
mkdir -p ${DR}
pushd ${DR}
MD_VER=`cat ../VERSION`
cmake -DCMAKE_SYSTEM_NAME=Windows -DCMAKE_TRY_COMPILE_TARGET_TYPE=STATIC_LIBRARY -DCMAKE_CXX_FLAGS="-std=c++11 -DCURL_STATICLIB -DMEGADEPTH_VERSION=$MD_VER -DWINDOWS_MINGW"  -DCMAKE_EXE_LINKER_FLAGS="-static-libgcc -static-libstdc++" CC=$CC CXX=$CXX AR=$AR RANLIB=$RANLIB -DCMAKE_BUILD_TYPE=Release ..
make ${bc}.exe
popd
cp ${DR}/${bc}.exe.exe ./megadepth.exe
rm -rf ${DR}

#!/bin/bash
set -o pipefail -o errexit 

#top level of incoming dir
#(where fully done analyses were copied/symlinked from original set of attempts)
search_dir=$1
#map between external sample accessions/UUIDs and study format: study<TAB>sample<TAB>secondary_sample_id (or just sample)
sample_ids_file=$2
destination_dir=$3
#e.g. "all"
analysis_type=$4
#.e.g ".tsv"
additional_suffix=$5

#now uses both study loworder digits *and* run loworder digits in manifest file names
find -L $search_dir -name "*.${analysis_type}${additional_suffix}" -size +0 | perl -ne 'BEGIN { open(IN,"<'${sample_ids_file}'"); %rids; while($line=<IN>) { chomp($line); @f=split(/\t/,$line); $rid=$f[2]; $run_acc=$f[1]; $rids{$run_acc}=[$rid, $f[0]]; } close(IN); } chomp; $f=$_; @f=split(/\//,$f); $fname=pop(@f); `pushd '${destination_dir}' && ln -fs ../$f && popd`; $fname=~/^([^\.]+)\./; $run_acc=$1; $run_acc=~/(..)$/; $acc_loworder=$1; ($rid, $study)=@{$rids{$run_acc}}; $study=~/(..)$/; $study_loworder=$1; push(@{$h{$study_loworder.".".$acc_loworder}},["'${destination_dir}'/$fname",$rid,"'${destination_dir}'/$fname",$run_acc]); END { open(ALL_OUT,">'${destination_dir}'/'${analysis_type}'.groups.manifest"); for $k (keys %h) { open(OUT,">'${destination_dir}'/'${analysis_type}'.$k.manifest"); for $a (@{$h{$k}}) { print ALL_OUT "".$a->[3]."\t'${analysis_type}'.$k.manifest\n"; print OUT "".join("\t",@$a)."\n"; } close(OUT); } close(ALL_OUT); }'

#touch $destination_dir/${analysis_type}.groups.manifest

mkdir -p docker.run.build
rsync -av megadepth_statlib docker.run.build/
rsync -av Dockerfile.run docker.run.build/Dockerfile
pushd docker.run.build/
VER=$(cat ../VERSION)
docker build --tag quay.io/broadsword/megadepth:${VER} --tag quay.io/broadsword/megadepth:latest .
popd

docker push quay.io/broadsword/megadepth:${VER}
docker push quay.io/broadsword/megadepth:latest

#!/usr/bin/env bash
#based in part on https://github.com/AnacondaRecipes/libnetcdf-feedstock/blob/master/recipe/build.sh
#and on the WiggleTools conda build script: 
#https://github.com/bioconda/bioconda-recipes/blob/master/recipes/wiggletools/build.sh
set -ex

declare -a CMAKE_PLATFORM_FLAGS
if [[ ${HOST} =~ .*darwin.* ]]; then
    CMAKE_PLATFORM_FLAGS+=(-DCMAKE_OSX_SYSROOT="${CONDA_BUILD_SYSROOT}")
else
    CMAKE_PLATFORM_FLAGS+=(-DCMAKE_TOOLCHAIN_FILE="${RECIPE_DIR}/cross-linux.cmake")
fi

if [[ ${DEBUG_C} == yes ]]; then
      CMAKE_BUILD_TYPE=Debug
else
      CMAKE_BUILD_TYPE=Release
fi

#build dynamic by default
bc="megadepth_dynamic"

cd $SRC_DIR
mkdir -p include lib
cp -r $PREFIX/include/* include/
cp -r $PREFIX/lib/* lib/

ln -fs ${RECIPE_DIR}/CMakeLists.txt ./

DR=build-release-temp
mkdir -p ${DR}
pushd ${DR}
cmake -DCMAKE_BUILD_TYPE=${CMAKE_BUILD_TYPE} -DCMAKE_INSTALL_PREFIX=${PREFIX} ${CMAKE_PLATFORM_FLAGS[@]} ..
make ${bc}
popd
cp $DR/${bc} $PREFIX/bin/megadepth

#!/usr/bin/env bash
set -xe

static=$1

if [[ -z $static ]]; then
    time ./megadepth http://stingray.cs.jhu.edu/data/temp/test.bam --prefix test.bam --threads 4 --bigwig --auc --min-unique-qual 10 --annotation tests/test_exons.bed --frag-dist --alts --include-softclip --only-polya --read-ends --test-polya --no-annotation-stdout --no-auc-stdout --filter-out 260 --add-chr-prefix human > test_run_out 2>&1

    time ./megadepth http://stingray.cs.jhu.edu/data/temp/test.cram --prefix test.cram --threads 4 --coverage --no-coverage-stdout --auc --min-unique-qual 10 --annotation 400 --frag-dist --alts --include-softclip --only-polya --read-ends --test-polya --no-annotation-stdout --no-auc-stdout --filter-out 260 > test_cram_run_out 2>&1
else
    time ./megadepth tests/test_noprefix.bam --prefix test.bam --threads 4 --bigwig --auc --min-unique-qual 10 --annotation tests/test_exons.bed --frag-dist --alts --include-softclip --only-polya --read-ends --test-polya --no-annotation-stdout --no-auc-stdout --filter-out 260 --add-chr-prefix human > test_run_out 2>&1
    time ./megadepth tests/test.cram --prefix test.cram --threads 4 --coverage --no-coverage-stdout --auc --min-unique-qual 10 --annotation 400 --frag-dist --alts --include-softclip --only-polya --read-ends --test-polya --no-annotation-stdout --no-auc-stdout --filter-out 260 > test_cram_run_out 2>&1
fi


diff <(sort tests/test.bam.orig.frags.tsv) <(sort test.bam.frags.tsv)
diff tests/test.bam.orig.alts.tsv test.bam.alts.tsv
diff tests/test.bam.orig.softclip.tsv test.bam.softclip.tsv
for f in annotation unique; do
    diff tests/test.bam.mosdepth.${f}.per-base.exon_sums.tsv test.bam.${f}.tsv
done
diff tests/test.bam.mosdepth.bwtool.all_aucs test.bam.auc.tsv

#test base coverage other than BigWigs
diff tests/test.cram.coverage.tsv test.cram.coverage.tsv

#test --annotation <window_bp_length>
cut -f 1,4 test.cram.window.tsv | perl -ne 'chomp; ($c,$v)=split(/\t/,$_); $h{$c}+=$v; END { for $c (sort keys %h) { print "$c\t".$h{$c}."\n"; }}' > test.cram.window.summed.tsv
diff tests/test.cram.window.summed.tsv test.cram.window.summed.tsv

#check --op mean with BAMs
./megadepth tests/test.bam --annotation tests/test_exons.bed --op mean --add-chr-prefix human > test.bam.mean
paste <(cut -f 4 test.bam.annotation.tsv) <(cut -f 2- test.bam.mean) | perl -ne 'chomp; $f=$_; ($sum,$s,$e,$m)=split(/\t/,$_); $d=($e-$s); $m2=$sum/$d; $m2=sprintf("%.2f",$m2); if($m != $m2) { print "$f\n"; $ret=1;} END { exit($ret); }'

./megadepth tests/test.bam | fgrep "ALL_READS_ALL_BASES" > auc.single
diff auc.single <(fgrep "ALL_READS_ALL_BASES" tests/test.bam.mosdepth.bwtool.all_aucs)

cat test.bam.starts.tsv test.bam.ends.tsv | sort -k1,1 -k2,2n -k3,3n > test_starts_ends.tsv
diff test_starts_ends.tsv <(sort -k1,1 -k2,2n -k3,3n tests/test.bam.read_ends.both.unique.tsv)

time ./megadepth tests/test2.bam --threads 4 --junctions --all-junctions --prefix test2.bam > test2_run_out 2>&1

diff tests/test2.bam.jxs.tsv test2.bam.jxs.tsv
diff tests/test2.bam.all_jxs.tsv test2.bam.all_jxs.tsv

#test just total auc
time ./megadepth test.bam.all.bw | grep "AUC" > test.bw1.total_auc
diff test.bw1.total_auc tests/testbw1.total_auc

#test bigwig2sums/auc
time ./megadepth test.bam.all.bw --annotation tests/testbw1.bed --auc --prefix test.bam.bw1 --no-annotation-stdout --no-auc-stdout
diff test.bam.bw1.annotation.tsv tests/testbw1.bed.out.tsv
diff test.bam.bw1.auc.tsv tests/testbw1.annot_auc

##use different order in BED file from what's in BW to test keep_order == true
time ./megadepth test.bam.all.bw --annotation tests/testbw2.bed --auc --prefix test.bam.bw2 --no-annotation-stdout --no-auc-stdout
diff test.bam.bw2.annotation.tsv tests/testbw2.bed.out.tsv
diff test.bam.bw2.auc.tsv tests/testbw2.annot_auc

#test bigwig2mean
time ./megadepth test.bam.all.bw --op mean --annotation tests/testbw2.bed --prefix bw2.mean --no-annotation-stdout >> test_run_out 2>&1
diff bw2.mean.annotation.tsv tests/testbw2.bed.mean

#test bigwig2min
time ./megadepth test.bam.all.bw --op min --annotation tests/testbw2.bed --prefix bw2.min --no-annotation-stdout >> test_run_out 2>&1
diff bw2.min.annotation.tsv tests/testbw2.bed.min

#test bigwig2max
time ./megadepth test.bam.all.bw --op max --annotation tests/testbw2.bed --prefix bw2.max --no-annotation-stdout >> test_run_out 2>&1
diff bw2.max.annotation.tsv tests/testbw2.bed.max

#now test same-start alignments for overlapping pairs
./megadepth tests/test3.bam --auc --coverage --prefix t3 --no-auc-stdout > t3.tsv
diff <(head -197 tests/test3.out.tsv) t3.tsv
diff <(tail -n1 tests/test3.out.tsv) t3.auc.tsv

#with uniques
./megadepth tests/test3.bam --coverage  --min-unique-qual 10 --bigwig --auc --prefix test3 --no-auc-stdout
diff tests/test3.auc.out.tsv test3.auc.tsv

#long reads support for junctions
./megadepth tests/long_reads.bam --junctions --prefix long_reads.bam --long-reads
diff tests/long_reads.bam.jxs.tsv long_reads.bam.jxs.tsv

#test bigwig2sum on remote BW
if [[ -z $static ]]; then
    time ./megadepth http://stingray.cs.jhu.edu/data/temp/megadepth.test.bam.all.bw --op mean --annotation tests/testbw2.bed --prefix bw2.remote.mean --no-annotation-stdout >> test_run_out 2>&1
    diff bw2.remote.mean.annotation.tsv tests/testbw2.bed.mean
fi

##only print sums use different order in BED file from what's in BW to test keep_order == true
time ./megadepth test.bam.all.bw --sums-only --annotation tests/testbw2.bed --prefix test.bam.bw2 > test.bam.bw2.annotation.tsv
diff test.bam.bw2.annotation.tsv <(cut -f 4 tests/testbw2.bed.out.tsv)

./megadepth http://stingray.cs.jhu.edu/data/temp/test.bam --prefix test.bam.names --threads 4 --alts --write-names --include-softclip --only-polya --test-polya --no-annotation-stdout --no-auc-stdout --filter-out 260 --add-chr-prefix human > test_run_out2 2>&1
diff test.bam.names.alts.tsv tests/test.bam.names.alts.tsv

#test multiple overlap types for BigWig annotation processing
./megadepth tests/bw.all_overlap_types.test_input.bw --annotation tests/gh_bug_9.bed --auc > test.bw.all_overlap_types.test_output.bed
diff test.bw.all_overlap_types.test_output.bed tests/bw.all_overlap_types.test_output.bed

#test faster mode with collapsed intervals in BigWig annotation processing
./megadepth tests/TCGA_BLCA_A13J.vcf.gz_cg_cov5.bw.bg.gz.chr1.60379.62229.bw --annotation tests/chr1.61863.62160.bed --no-annotation-stdout --prefix TCGA_BLCA_A13J_vs_chr1.61863.62160
diff TCGA_BLCA_A13J_vs_chr1.61863.62160.annotation.tsv tests/TCGA_BLCA_A13J_vs_chr1.61863.62160.annotation.tsv

#test that we're catching out of order chromosomes
output=$(./megadepth tests/TCGA_BLCA_A13J.vcf.gz_cg_cov5.bw.bg.gz.chr1.60379.62229.bw --annotation tests/chr1.61863.62160.bad_chrm_order.bed 2>&1)
fgrep "falling back" <(echo "$output")

#clean up any previous test files
rm -f test*tsv test*auc bw2* test3* test2* t3.* long_reads.bam.jxs.tsv test_run_out *null*.unique.tsv test.*.bw auc.single test.bam.mean test.cram.coverage.tsv test_cram_run_out test.cram.coverage.tsv.summed test.bw.all_overlap_types.test_output.bed TCGA_BLCA_A13J_vs_chr1.61863.62160.annotation.tsv

#!/usr/bin/env bash

set -ex

working_dir=$(dirname $0)
pushd $working_dir

ln -fs CMakeLists.txt.ci CMakeLists.txt

#clear symlink main lib dirs
rm -rf zlib htslib libBigWig libdeflate build-release-temp

export APPLE_VER=12
OSXCROSS_ROOT=/opt/osxcross/target/bin
export PATH=$OSXCROSS_ROOT:$PATH
export OSX_ARCH=x86_64
export OSX_CC=o64-gcc
export OSX_CXX=o64-g++
export CC=${OSX_CC}
export CXX=${OSX_CXX}
export AR=${OSXCROSS_ROOT}/$OSX_ARCH-apple-darwin${APPLE_VER}-ar
export RANLIB=${OSXCROSS_ROOT}/$OSX_ARCH-apple-darwin${APPLE_VER}-ranlib
export compiler=$OSX_ARCH-apple-darwin${APPLE_VER}

#only build statlib for macos, no static support:
#see https://stackoverflow.com/questions/5259249/creating-static-mac-os-x-c-build
bc=megadepth_statlib

if [[ ! -s libdeflate_macos ]] ; then
    ./get_libdeflate.sh $compiler macos
fi
ln -fs libdeflate_macos libdeflate

export CFLAGS="-I../libdeflate"
export LDFLAGS="-L../libdeflate -ldeflate"
if [[ ! -e htslib_macos/libhts.a ]] ; then
    ./get_htslib.sh $compiler macos
fi
ln -fs htslib_macos htslib

if [[ ! -s libBigWig_macos ]] ; then
    ./get_libBigWig.sh macos
    pushd libBigWig_macos
    make clean
    make -f Makefile.fpic lib-static
    popd
fi
ln -fs libBigWig_macos libBigWig

export CFLAGS=
export LDFLAGS=

set -x

export LD_LIBRARY_PATH=./htslib:./libBigWig:$LD_LIBRARY_PATH

DR=build-release-temp
mkdir -p ${DR}
pushd ${DR}
#CC=${OSX_CC} CXX=${OSX_CXX} cmake -DCMAKE_BUILD_TYPE=Release -DCMAKE_AR=/opt/osxcross/target/bin/$OSX_ARCH-apple-darwin${APPLE_VER}-ar -DCMAKE_RANLIB=/opt/osxcross/target/bin/$OSX_ARCH-apple-darwin${APPLE_VER}-ranlib -D CMAKE_C_COMPILER=${OSX_CC} -D CMAKE_CXX_COMPILER=${OSX_CXX} ..
#CC=${OSX_CC} CXX=${OSX_CXX} AR=/opt/osxcross/target/bin/$OSX_ARCH-apple-darwin${APPLE_VER}-ar RANLIB=/opt/osxcross/target/bin/$OSX_ARCH-apple-darwin${APPLE_VER}-ranlib make ${bc}
cmake -DCMAKE_BUILD_TYPE=Release -DCMAKE_AR=${AR} -DCMAKE_RANLIB=${RANLIB} -D CMAKE_C_COMPILER=${OSX_CC} -D CMAKE_CXX_COMPILER=${OSX_CXX} ..
make ${bc}
popd
cp ${DR}/${bc} ./megadepth_macos
#./megadepth_macos --version
rm -rf ${DR}

#docker run --ulimit core=-1 -it --volume `pwd`:/build:rw --entrypoint=/bin/bash a3939c35343f -i
docker run --ulimit core=-1 -it --volume `pwd`:/build:rw --entrypoint=/build/build_no_container_windows.sh a3939c35343f -i

#!/usr/bin/env bash

set -ex

compiler=$1
platform=$2

target_dir=libdeflate
if [[ -z $SUBMODULE ]]; then
    if [[ -n $platform ]]; then
        target_dir="libdeflate_"${platform}
    fi
    VER=1.6
    TARGZ=${VER}.tar.gz
    FN=libdeflate-${TARGZ}
    DIR=libdeflate-${VER}
    curl -L https://github.com/ebiggers/libdeflate/archive/v${TARGZ} > $FN
    tar -zxvf $FN
    rm -f ${FN}
    mv $DIR $target_dir
fi
pushd $target_dir
target="libdeflate.a"
if [[ -z $compiler ]]; then
    #from https://github.com/samtools/htslib/issues/688
    make CFLAGS="$CFLAGS -fPIC -O3" $target
else
    if [[ "$platform" == "windows" ]]; then
        make CC=${compiler}-gcc CFLAGS='-O3' libdeflatestatic.lib
        ln -fs libdeflatestatic.lib libdeflate.a
    else
        make CC=${compiler}-gcc CFLAGS='-fPIC -O3' $target
    fi
fi
popd

#!/usr/bin/env bash

set -ex

#macos:
#   x86_64-apple-darwin12 (CC=o64-gcc)
#OR
#   i386-apple-darwin1 (CC=o32-gcc)
#windows:
#   x86_64-w64-mingw32 (64bit)
#OR
#   i686-w64-mingw32 (32bit)

compiler=$1
#"macos" or "windows" (or nothing for normal linux build)
platform=$2

target_dir=htslib
if [[ -n $platform && "$platform" != "hbb" ]]; then
    target_dir="htslib_"${platform}
fi

#VER=1.9
#VER=1.10.2
VER=1.11
#in case we're not using git submodules to pull dependencies
if [[ -z $SUBMODULE ]]; then
    ar=htslib-${VER}.tar.bz2
    if [[ ! -s $target_dir ]] ; then
        curl -OL https://github.com/samtools/htslib/releases/download/${VER}/${ar}
        bzip2 -dc ${ar} | tar xvf - 
        rm -f ${ar}
        mv htslib-${VER} $target_dir
    fi
fi
pushd $target_dir

autoheader
autoconf
make clean

if [[ "$compiler" == "linux" ]]; then
    if [[ "$platform" == "hbb" ]]; then
        ./configure --enable-libcurl --disable-bz2 --disable-lzma --with-libdeflate
        make libhts.a
    else
        ./configure --disable-libcurl --disable-bz2 --disable-lzma --with-libdeflate
        make
    fi
else
    if [[ "$platform" == "macos" ]]; then
    	./configure --enable-plugins --enable-libcurl --disable-bz2 --disable-lzma --with-libdeflate --host=$compiler
        #inherit CC, AR, and RANLIB from build_no_container_xcross.sh
        echo $CC
        echo $AR
        echo $RANLIB
        #only make static lib for cross-compilation for now
        #export CC=/opt/osxcross/target/bin/${compiler}-gcc
        #export AR=/opt/osxcross/target/bin/${compiler}-ar
        #export RANLIB=/opt/osxcross/target/bin/${compiler}-ranlib
    else # windows
    	./configure --disable-bz2 --disable-lzma --with-libdeflate --host=$compiler
        export CC=${compiler}-gcc
        export AR=${compiler}-ar
        export RANLIB=${compiler}-ranlib
    fi
    make CC=$CC AR=$AR RANLIB=$RANLIB libhts.a
fi
popd

#for interactive debugging switch to just bash shell
#docker run --ulimit core=-1 -it --rm --volume `pwd`:/build:rw --entrypoint=/bin/bash de2c52df2597 -i
docker run --ulimit core=-1 -it --rm --volume `pwd`:/build:rw --entrypoint=/build/build_no_container_hbb.sh de2c52df2597 -i

#!/usr/bin/env bash
export LD_LIBRARY_PATH=/data7/megadepth/libBigWig:/data7/megadepth/htslib:$LD_LIBRARY_PATH
MD=../mosdepth
BT=~/bwtool_mine2/bwtool
B2B='python3 ../bam2bigwig.py'
KB2B=/data/kent_tools/bigWigToBedGraph
WT=wiggletools
EXONS=/data7/megadepth/exons.bed

EXONS=$1
BAM=$2

echo -n "" > ${BAM}.per-base.bed.gz.bw.aucs
echo -n "" > ${BAM}.annotated_aucs
for t in default unique; do
    qarg=`perl -e '$t='${t}'; print "0" if($t eq "default"); print "10" if($t eq "unique");'`
    time $MD -F260 -t 4 -Q${qarg} ${BAM}.${t} $BAM
    time cat <(samtools view -H $BAM) <(zcat ${BAM}.${t}.per-base.bed.gz) | $B2B ${BAM}.${t}.per-base.bed.gz.bw
    time $BT summary $EXONS ${BAM}.${t}.per-base.bed.gz.bw /dev/stdout -fill=0 -with-sum -keep-bed -decimals=0 | cut -f1-3,10 | sort -k1,1 -k2,2n -k3,3n > ${BAM}.${t}.per-base.bed.gz.bw.sums.bed
    $KB2B ${BAM}.${t}.per-base.bed.gz.bw ${BAM}.${t}.per-base.bed.gz.bw.sums.bed.bg
    $WT AUC ${BAM}.${t}.per-base.bed.gz.bw | perl -ne 'BEGIN { $t='${t}'; } chomp; $f=$_; $f=~s/\.0+$//; print "ALL_READS_ALL_BASES\t$f\n" if($t eq "default"); print "UNIQUE_READS_ALL_BASES\t$f\n" if($t eq "unique");' >> ${BAM}.per-base.bed.gz.bw.aucs
    cat ${BAM}.${t}.per-base.bed.gz.bw.sums.bed | perl -ne 'BEGIN { $t='${t}'; } chomp; ($c,$s,$e,$v)=split(/\t/,$_); $f+=$v; END { print "ALL_READS_ANNOTATED_BASES\t$f\n" if($t eq "default"); print "UNIQUE_READS_ANNOTATED_BASES\t$f\n" if($t eq "unique"); }' >> ${BAM}.annotated_aucs
done
cat ${BAM}.per-base.bed.gz.bw.aucs >> ${BAM}.annotated_aucs

---
title: "megadepth quick start guide"
author: 
  - name: David Zhang
    affiliation:
    - UCL
    email: david.zhang.12@ucl.ac.uk
  - name: Leonardo Collado-Torres
    affiliation:
    - &libd Lieber Institute for Brain Development, Johns Hopkins Medical Campus
    - &ccb Center for Computational Biology, Johns Hopkins University
    email: lcolladotor@gmail.com
output: 
  BiocStyle::html_document:
    self_contained: yes
    toc: true
    toc_float: true
    toc_depth: 2
    code_folding: show
date: "`r doc_date()`"
package: "`r pkg_ver('megadepth')`"
vignette: >
  %\VignetteIndexEntry{megadepth quick start guide}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}  
---

```{r setup, include = FALSE}
knitr::opts_chunk$set(
    collapse = TRUE,
    comment = "#>",
    crop = NULL ## Related to https://stat.ethz.ch/pipermail/bioc-devel/2020-April/016656.html
)
```


```{r vignetteSetup, echo=FALSE, message=FALSE, warning = FALSE}
## Track time spent on making the vignette
startTime <- Sys.time()

## Bib setup
library("RefManageR")

## Write bibliography information
bib <- c(
    R = citation(),
    BiocStyle = citation("BiocStyle")[1],
    knitr = citation("knitr")[1],
    rmarkdown = citation("rmarkdown")[1],
    sessioninfo = citation("sessioninfo")[1],
    testthat = citation("testthat")[1],
    megadepth = citation("megadepth")[1],
    megadepthpaper = citation("megadepth")[2],
    bioconductor2015 = RefManageR::BibEntry(
        bibtype = "Article",
        key = "bioconductor2015",
        author = "Wolfgang Huber and Vincent J Carey and Robert Gentleman and Simon Anders and Marc Carlson and Benilton S Carvalho and Hector Corrada Bravo and Sean Davis and Laurent Gatto and Thomas Girke and Raphael Gottardo and Florian Hahne and Kasper D Hansen and Rafael A Irizarry and Michael Lawrence and Michael I Love and James MacDonald and Valerie Obenchain and Andrzej K Oleś and Hervé Pagès and Alejandro Reyes and Paul Shannon and Gordon K Smyth and Dan Tenenbaum and Levi Waldron and Martin Morgan",
        title = "Orchestrating high-throughput genomic analysis with Bioconductor",
        year = 2015, doi = "10.1038/nmeth.3252",
        journal = "Nature Methods",
        journaltitle = "Nat Methods"
    ),
    RefManageR = citation("RefManageR")[1],
    rtracklayer = citation("rtracklayer")
)
```


The goal of `r Biocpkg("megadepth")` is to provide an R interface to the command line tool [Megadepth](https://github.com/ChristopherWilks/megadepth) for BigWig and BAM related utilities created by [Christopher Wilks](https://twitter.com/chrisnwilks) `r Citep(bib[["megadepthpaper"]])`. This R package enables **fast** processing of BigWig files on downstream packages such as [dasper](https://bioconductor.org/packages/dasper) and [recount3](https://bioconductor.org/packages/recount3). The [Megadepth](https://github.com/ChristopherWilks/megadepth) software also provides utilities for processing BAM files and extracting coverage information from them.

Here is an illustration on how fast `r Biocpkg("megadepth")` is compared to other tools for processing local and remote BigWig files.

```{r "runtime", out.width="100%", echo = FALSE, fig.cap = "Timing results. Timing comparison for processing 1,000 genomic regions on a bigWig file that is available on the local disk or on a remote resource. We compared megadepth against rtracklayer and pyBigWig. megadepth is typically faster that these other software solutions for computing the mean coverage across a set of 1,000 input genomic regions. Check <https://github.com/LieberInstitute/megadepth/tree/devel/analysis> for more details."}
knitr::include_graphics("https://raw.githubusercontent.com/LieberInstitute/megadepth/devel/analysis/md_rt_pybw_runtime.png")
```


Throughout the documentation we use a capital `M` to refer to the software by Christopher Wilks and a lower case `m` to refer to this R/Bioconductor package.


# Basics

## Install `megadepth`

`R` is an open-source statistical environment which can be easily modified to enhance its functionality via packages. `r Biocpkg("megadepth")` is a `R` package available via the [Bioconductor](http://bioconductor.org) repository for packages. `R` can be installed on any operating system from [CRAN](https://cran.r-project.org/) after which you can install `r Biocpkg("megadepth")` by using the following commands in your `R` session:

```{r "install", eval = FALSE}
if (!requireNamespace("BiocManager", quietly = TRUE)) {
    install.packages("BiocManager")
}

BiocManager::install("megadepth")

## Check that you have a valid Bioconductor installation
BiocManager::valid()
```

## Required knowledge

`r Biocpkg("megadepth")` is based on many other packages and in particular in those that have implemented the infrastructure needed for dealing with RNA-seq data and high-throughput sequencing data in general. You might benefit from being familiar with the BigWig file format and the `r Biocpkg("rtracklayer")` for importing those files into R as well as exporting BED files `r Citep(bib[["rtracklayer"]])`. If you are working with annoation files, `r Biocpkg("GenomicFeatures")` and `r Biocpkg("GenomicRanges")` will also be useful to you.

If you are asking yourself the question "Where do I start using Bioconductor?" you might be interested in [this blog post](http://lcolladotor.github.io/2014/10/16/startbioc/#.VkOKbq6rRuU).

## Asking for help

As package developers, we try to explain clearly how to use our packages and in which order to use the functions. But `R` and `Bioconductor` have a steep learning curve so it is critical to learn where to ask for help. The blog post quoted above mentions some but we would like to highlight the [Bioconductor support site](https://support.bioconductor.org/) as the main resource for getting help: remember to use the `megadepth` tag and check [the older posts](https://support.bioconductor.org/t/megadepth/). Other alternatives are available such as creating GitHub issues and tweeting. However, please note that if you want to receive help you should adhere to the [posting guidelines](http://www.bioconductor.org/help/support/posting-guide/). It is particularly critical that you provide a small reproducible example and your session information so package developers can track down the source of the error.

## Citing `megadepth`

We hope that `r Biocpkg("megadepth")` will be useful for your research. Please use the following information to cite the package and the overall approach. Thank you!

```{r "citation"}
## Citation info
citation("megadepth")
```

# Quick start

To get started, we need to load the `r Biocpkg("megadepth")` package into our R session. This will load all the required dependencies.

```{r "start", message=FALSE}
library("megadepth")
```

Once we have the R package loaded, we need to install the [Megadepth](https://github.com/ChristopherWilks/megadepth) software. We can do so with `install_megadepth()`, which downloads a binary for your OS (Linux, Windows or macOS) ^[Please check [Megadepth](https://github.com/ChristopherWilks/megadepth) for instructions on how to compile the software from source if the binary version doesn't work for you.]. We can then use with an example BigWig file to compute the coverage at a set of regions.

```{r "install_software"}
## Install the latest version of Megadepth
install_megadepth(force = TRUE)
```

Next, we might want to use `r Biocpkg("megadepth")` to quantify the coverage at a set of regions of the genome of interest to us. Here we will use two example files that are include in the package for illustration and testing purposes. One of them is a [bigWig file](https://genome.ucsc.edu/goldenPath/help/bigWig.html) that contains the base-pair coverage information for a sample of interest and the second one is [BED file](https://genome.ucsc.edu/FAQ/FAQformat.html#format1) which contains the genomic region coordinates of interest. So we first locate them.

```{r "locate_example_bw"}
## Next, we locate the example BigWig and annotation files
example_bw <- system.file("tests", "test.bam.all.bw",
    package = "megadepth", mustWork = TRUE
)
annotation_file <- system.file("tests", "testbw2.bed",
    package = "megadepth", mustWork = TRUE
)

## Where are they?
example_bw
annotation_file
```

Once we have located the example files we can proceed to calculating the base-pair coverage for our genomic regions of interest. There are several ways to do this with `r Biocpkg("megadepth")`, but here we use the user-friendly function `get_coverage()`. This function will perform a given operation **op** on the bigWig file for a given set of regions of interest (_annotation_). One of those operations is to compute the mean base-pair coverage for each input region. This is what we'll do with our example bigWig file.

```{r example}
## We can then use megadepth to compute the coverage
bw_cov <- get_coverage(
    example_bw,
    op = "mean",
    annotation = annotation_file
)
bw_cov
```

`get_coverage()` returns an object that is familiar to `r Biocpkg("GenomicRanges")` users, that is, a `GRanges` object that can be used with other Bioconductor software packages `r Citep(bib[["bioconductor2015"]])`.

This example is just the tip of the iceberg, as [Megadepth](https://github.com/ChristopherWilks/megadepth) and thus `r Biocpkg("megadepth")` can do a lot of useful processing operations on BAM and bigWig files.

# Users guide

## Command interface

[Megadepth](https://github.com/ChristopherWilks/megadepth) is very powerful and can do a lot of different things. The R/Bioconductor package provides two functions for interfacing with [Megadepth](https://github.com/ChristopherWilks/megadepth), `megadepth_cmd()` and `megadepth_shell()`. For the first one, `megadepth_cmd()`, you need to know the actual command syntax you want to use and format it accordingly. If you are more comfortable with R functions, `megadepth_shell()` uses `r BiocStyle::CRANpkg("cmdfun")` to power this interface and capture the standard output stream into R.

To make it easier to use, `megadepth` includes functions that simplify the number of arguments, read in the output files, and converts them into R/Bioconductor friendly objects, such as `get_coverage()` illustrated previously in the quick start section.

We hope that you'll find `megadepth` and [Megadepth](https://github.com/ChristopherWilks/megadepth) useful for your work. If you are interested in checking how **fast** `megadepth` is, check out the [**speed analysis**](https://github.com/LieberInstitute/megadepth/tree/devel/analysis) comparison against other tools. Note that the size of the files used and the number of genomic regions queried will affect the speed comparisons.

```{r "interface_options"}
## R-like interface
## that captures the standard output into R
head(megadepth_shell(help = TRUE))

## Command-like interface
megadepth_cmd("--help")
```

```{r "show_help", echo = FALSE}
x <- megadepth_shell(help = TRUE)
cat(paste0(x, "\n"))
```

## BAM to bigWig

One use case of [Megadepth](https://github.com/ChristopherWilks/megadepth) is to convert BAM files to bigWig coverage files. To simplify this process and verify that you are not accidentally overwriting valuable files, `r Biocpkg("megadepth")` provides the function `bam_to_bigwig()`. To illustrate this functionality, we first locate an example BAM file. We then generate the output bigWig files

```{r "bam_to_bigwig", eval = !xfun::is_windows()}
## Find the example BAM file
example_bam <- system.file("tests", "test.bam",
    package = "megadepth", mustWork = TRUE
)

## Create the BigWig file
## Currently Megadepth does not support this on Windows
example_bw <- bam_to_bigwig(example_bam, overwrite = TRUE)

## Path to the output files generated by bam_to_bigwig()
example_bw
```

Currently this functionality does not work on Windows. In which case, you can continue the vignette with the following example bigWig file.

```{r "bam_to_bigwig_windows", eval = xfun::is_windows()}
## On Windows, use the example bigWig file that is already included in
## the R package
example_bw <- system.file("tests", "test.bam.all.bw",
    package = "megadepth", mustWork = TRUE
)
```


## Summarize coverage over regions

Once you have a biWig file, you might want to quantify the mean or total expression across a set of genomic coordinates. bigWig files are typically used by genome browsers, and as part of the `r Biocpkg('recount')` and `r Biocpkg('recount3')` projects we have released thousands of them. Before we expand more complex uses cases, you might be interested in `get_coverage()`. This function will use [Megadepth](https://github.com/ChristopherWilks/megadepth) to create a tab-separated value (TSV) file containing the coverage summary information ^[Sum, mean, min or max base-pair coverage for each region.] for a given input file that can be read into R using `read_coverage()` ^[If you prefer a `tibble`, use `read_coverage_table()`.] as shown below with an example set of genomic regions of interest (_annotation_).

```{r "get_coverage"}
## Next, we locate the example annotation BED file
annotation_file <- system.file("tests", "testbw2.bed",
    package = "megadepth", mustWork = TRUE
)

## Now we can compute the coverage
bw_cov <- get_coverage(example_bw, op = "mean", annotation = annotation_file)
bw_cov
```

If you are familiar with `r Biocpkg("rtracklayer")`, you'll notice that the coverage summaries are basically the same to the one that can be generated with `rtracklayer::import.bw()`, which is what `r Biocpkg("derfinder")` uses internally.

```{r "rtracklayer_derfinder"}
## Checking with derfinder and rtracklayer
bed <- rtracklayer::import(annotation_file)

## The file needs a name
names(example_bw) <- "example"

## Read in the base-pair coverage data
regionCov <- derfinder::getRegionCoverage(
    regions = bed,
    files = example_bw,
    verbose = FALSE
)

## Summarize the base-pair coverage data.
## Note that we have to round the mean to make them comparable.
testthat::expect_equivalent(
    round(sapply(regionCov[c(1, 3:4, 2)], function(x) mean(x$value)), 2),
    bw_cov$score,
)

## If we compute the sum, there's no need to round
testthat::expect_equivalent(
    sapply(regionCov[c(1, 3:4, 2)], function(x) sum(x$value)),
    get_coverage(example_bw, op = "sum", annotation = annotation_file)$score,
)
```

## BAM to junctions

[Megadepth](https://github.com/ChristopherWilks/megadepth) provides utilities that might be of use for future work or that were developed for building `r Biocpkg('recount3')`. One of these features is the possibility to extract locally co-ocurring junctions from a BAM file as described in the [Megadepth documentation](https://github.com/ChristopherWilks/megadepth#megadepth-pathtobamfile---junctions). This feature works only for junctions for which a read or (read pair) has 2 or more junctions.

To illustrate this functionality, we will use an example BAM file and generate the locally co-occurring junction table with `bam_to_junctions()`. We'll then read in the data using `read_junction_table()` ^[The `strand` columns have been switched from 0s and 1s to `+` and `-` for the forward and reverse strands, to match frequently used Bioconductor packages.]. `process_junction_table()` can then be used to convert the junctions into a STAR-compatible format. 

```{r "bam_to_junctions"}
## Find the example BAM file
example_bam <- system.file("tests", "test.bam",
    package = "megadepth", mustWork = TRUE
)

## Run bam_to_junctions()
example_jxs <- bam_to_junctions(example_bam, overwrite = TRUE)

## Path to the output file generated by bam_to_junctions()
example_jxs

## Read the data as a tibble using the format specified at
## https://github.com/ChristopherWilks/megadepth#megadepth-pathtobamfile---junctions
example_jxs <- read_junction_table(example_jxs)

example_jxs

process_junction_table(example_jxs)
```


## Teams involved

`r Biocpkg('megadepth')` was made possible to [David Zhang](https://twitter.com/dyzhang32), the author of `r Biocpkg("dasper")`, and a member of the [Mina Ryten](https://snca.atica.um.es/)'s lab at UCL.

The `ReCount` family involves the following teams:

* [Ben Langmead's lab](http://www.langmead-lab.org/) at JHU Computer Science
* [Kasper Daniel Hansen's lab](https://www.hansenlab.org/)  at JHBSPH Biostatistics Department
* [Leonardo Collado-Torres](http://lcolladotor.github.io/) and [Andrew E. Jaffe](http://aejaffe.com/) from [LIBD](https://www.libd.org/)
* [Abhinav Nellore's lab](http://nellore.bio/)  at OHSU
* [Jeff Leek's lab](http://jtleek.com/) at JHBSPH Biostatistics Deparment
* Data hosted by [SciServer from IDIES at JHU](https://www.sciserver.org/)



## Other related tools

The `ReCount` team has worked on several software solutions and projects that complement each other and enable you to re-use public RNA-seq data. Another Bioconductor package that you might be highly interested in is `r Biocpkg("snapcount")`, which allows you to use the [Snaptron web services](http://snaptron.cs.jhu.edu/). In particular, `r Biocpkg("snapcount")` is best for queries over a particular subset of genes or intervals across all or most of the samples in `recount2`/`Snaptron`.

We remind you that the **main documentation website** for all the `recount3`-related projects is available at [**recount.bio**](https://LieberInstitute/github.io/recount3-docs). Please check that website for more information about how this R/Bioconductor package and other tools are related to each other.

**Thank you!**

P.S. An [alternative version of this vignette is available](https://LieberInstitute.github.io/megadepth/) that was made using `r CRANpkg("pkgdown")`.



# Reproducibility

The `r Biocpkg("megadepth")` package `r Citep(bib[["megadepth"]])` was made possible thanks to:

* R `r Citep(bib[["R"]])`
* `r Biocpkg("BiocStyle")` `r Citep(bib[["BiocStyle"]])`
* `r CRANpkg("knitr")` `r Citep(bib[["knitr"]])`
* `r CRANpkg("rmarkdown")` `r Citep(bib[["rmarkdown"]])`
* `r CRANpkg("RefManageR")` `r Citep(bib[["RefManageR"]])`
* `r CRANpkg("sessioninfo")` `r Citep(bib[["sessioninfo"]])`
* `r CRANpkg("testthat")` `r Citep(bib[["testthat"]])`

This package was developed using `r BiocStyle::Biocpkg("biocthis")`.


Code for creating the vignette

```{r createVignette, eval=FALSE}
## Create the vignette
library("rmarkdown")
system.time(render("megadepth.Rmd", "BiocStyle::html_document"))

## Extract the R code
library("knitr")
knit("megadepth.Rmd", tangle = TRUE)
```

Date the vignette was generated.

```{r reproduce1, echo=FALSE}
## Date the vignette was generated
Sys.time()
```

Wallclock time spent generating the vignette.

```{r reproduce2, echo=FALSE}
## Processing time in seconds
totalTime <- diff(c(startTime, Sys.time()))
round(totalTime, digits = 3)
```

`R` session information.

```{r reproduce3, echo=FALSE}
## Session info
library("sessioninfo")
options(width = 120)
session_info()
```



# Bibliography

This vignette was generated using `r Biocpkg("BiocStyle")` `r Citep(bib[["BiocStyle"]])`
with `r CRANpkg("knitr")` `r Citep(bib[["knitr"]])` and `r CRANpkg("rmarkdown")` `r Citep(bib[["rmarkdown"]])` running behind the scenes.

Citations made with `r CRANpkg('RefManageR')` `r Citep(bib[['RefManageR']])`.

```{r vignetteBiblio, results = "asis", echo = FALSE, warning = FALSE, message = FALSE}
## Print bibliography
PrintBibliography(bib, .opts = list(hyperlink = "to.doc", style = "html"))
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/read_junction.R
\name{read_junction_table}
\alias{read_junction_table}
\title{Read a junction TSV file created by Megadepth as a table}
\usage{
read_junction_table(tsv_file)
}
\arguments{
\item{tsv_file}{A \code{character(1)} specifying the path to the tab-separated
(TSV) file created manually using \code{megadepth_shell()} or on a previous
\code{bam_to_junctions()} run.}
}
\value{
A \code{tibble::tibble()} with the junction data that follows the format
specified at \url{https://github.com/ChristopherWilks/megadepth#junctions}.
}
\description{
Read an \verb{*all_jxs.tsv} or \verb{*jxs.tsv} file created by \code{bam_to_junctions()} or
manually by the user using Megadepth. The rows of a \verb{*jxs.tsv} can have
either 7 or 14 columns, which can lead to warnings when reading in - these
are safe to ignore. For details on the format of the input TSV file, check
\url{https://github.com/ChristopherWilks/megadepth#junctions}.
}
\examples{

## Install if necessary
install_megadepth()

## Find the example BAM file
example_bam <- system.file("tests", "test.bam",
    package = "megadepth", mustWork = TRUE
)

## Run bam_to_junctions()
example_jxs <- bam_to_junctions(example_bam, overwrite = TRUE)

## Read the junctions in as a tibble
all_jxs <- read_junction_table(example_jxs[["all_jxs.tsv"]])

all_jxs
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bam_to_junctions.R
\name{bam_to_junctions}
\alias{bam_to_junctions}
\title{Extract junctions from a BAM file}
\usage{
bam_to_junctions(
  bam_file,
  prefix = file.path(tempdir(), basename(bam_file)),
  all_junctions = TRUE,
  junctions = FALSE,
  long_reads = FALSE,
  filter_in = 65535,
  filter_out = 260,
  overwrite = FALSE
)
}
\arguments{
\item{bam_file}{A \code{character(1)} with the path to the input BAM file.}

\item{prefix}{A \code{character(1)} specifying the output file prefix. This
function creates a file called \code{prefix.jxs.tsv}. By default, the prefix is
the BAM file name and the file is created in the \code{tempdir()} and will be
deleted after you close your R session.}

\item{all_junctions}{A \code{logical(1)} indicating whether to obtain all
junctions.}

\item{junctions}{A \code{logical(1)} indicating whether to obtain co-occurring jx
coordinates.}

\item{long_reads}{A \code{logical(1)} indicating whether to increase the buffer
size to accommodate for long-read RNA-sequencing.}

\item{filter_in}{A \code{integer(1)} used to filter in read alignments. See
https://github.com/ChristopherWilks/megadepth#bamcram-processing and
https://samtools.github.io/hts-specs/SAMv1.pdf for further documentation on
how to apply this parameter.}

\item{filter_out}{A \code{integer(1)} used to filter out read alignments. See
https://github.com/ChristopherWilks/megadepth#bamcram-processing and
https://samtools.github.io/hts-specs/SAMv1.pdf for further documentation on
how to apply this parameter.}

\item{overwrite}{A \code{logical(1)} specifying whether to overwrite the output
file(s), if they exist already.}
}
\value{
A \code{character(1)} with the path to the output junction tsv file.
}
\description{
Given a BAM file, extract junction information including co-ordinates,
strand, anchor length for each junction read. For details on the format of
the output TSV file, check
\url{https://github.com/ChristopherWilks/megadepth#junctions}.
}
\examples{

## Install if necessary
install_megadepth()

## Find the example BAM file
example_bam <- system.file("tests", "test.bam",
    package = "megadepth", mustWork = TRUE
)

## Run bam_to_junctions()
example_jxs <- bam_to_junctions(example_bam, overwrite = TRUE)

## Path to the output file generated by bam_to_junctions()
example_jxs
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/read_junction.R
\name{process_junction_table}
\alias{process_junction_table}
\title{Process junctions into a STAR compatible format}
\usage{
process_junction_table(all_jxs)
}
\arguments{
\item{all_jxs}{A \code{tibble::tibble()} containing junction data ("all.jxs.tsv")
generated by \code{bam_to_junctions(all_junctions = TRUE)} and imported through
\code{megadepth::read_junction_table()}.}
}
\value{
Processed junctions in a STAR-compatible format.
}
\description{
Parses the junctions outputted from \code{process_junction_table()} into an STAR
compatible format (SJ.out) for more convenient use in downstream analyses.
The columns strand, intron_motif and annotated will always be 0 (undefined)
but can be derived through extracting the dinucleotide motifs for the given
reference coordinates for canonical motifs. This function is an
R-implementation of the Megadepth helper script, on which further details of
column definitions can be found:
\url{https://github.com/ChristopherWilks/megadepth#junctions}.
}
\examples{

## Install if necessary
install_megadepth()

## Find the example BAM file
example_bam <- system.file("tests", "test.bam",
    package = "megadepth", mustWork = TRUE
)

## Run bam_to_junctions()
example_jxs <- bam_to_junctions(example_bam, overwrite = TRUE)

## Read the junctions in as a tibble
all_jxs <- read_junction_table(example_jxs[["all_jxs.tsv"]])

## Process junctions into a STAR-compatible format
processed_jxs <- process_junction_table(all_jxs)

processed_jxs
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bam_to_bigwig.R
\name{bam_to_bigwig}
\alias{bam_to_bigwig}
\title{Convert a BAM file to a BigWig}
\usage{
bam_to_bigwig(
  bam_file,
  prefix = file.path(tempdir(), basename(bam_file)),
  min_unique_qual = FALSE,
  double_count = FALSE,
  overwrite = FALSE
)
}
\arguments{
\item{bam_file}{A \code{character(1)} with the path to the input BAM file.}

\item{prefix}{A \code{character(1)} specifying the output file prefix. This
function creates a BigWig file called \verb{\{prefix\}.all.bw}. By default, the
prefix is the BAM file name and the file is created in the \code{tempdir()} and
will be deleted after you close your R session.}

\item{min_unique_qual}{A \code{integer(1)} specifying a mapping quality threshold
and only bases above this will be used to generate the BigWig. If set to
\code{FALSE} this argument is not used by Megadepth. Otherwise it will generate
files \verb{\{prefix\}.unique.bw} and \verb{\{prefix\}.unique.tsv}.}

\item{double_count}{A \code{logical(1)} determining whether to count the
overlapping ends of paired ends reads twice.}

\item{overwrite}{A \code{logical(1)} specifying whether to overwrite the output
file(s), if they exist already.}
}
\value{
A \code{character()} with the path to the output files(s).
}
\description{
Given an input BAM file, convert this to the BigWig format which can then be
used in \code{get_coverage()}.
}
\details{
Note that this functionality is currently not supported on Windows by
Megadepth.
}
\examples{

## Install the latest version if necessary
install_megadepth(force = TRUE)

## Find the example BAM file
example_bam <- system.file("tests", "test.bam",
    package = "megadepth", mustWork = TRUE
)

## Create the BigWig file
## Currently Megadepth does not support this on Windows
if (!xfun::is_windows()) {
    example_bw <- bam_to_bigwig(example_bam, overwrite = TRUE)

    ## Path to the output file(s) generated by bam_to_bigwig()
    example_bw

    ## Use the all.bw file in get_coverage(), first find an annotation file
    annotation_file <- system.file("tests", "testbw2.bed",
        package = "megadepth", mustWork = TRUE
    )

    ## Compute the coverage
    bw_cov <- get_coverage(
        example_bw["all.bw"],
        op = "mean",
        annotation = annotation_file
    )
    bw_cov
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/read_coverage.R
\name{read_coverage}
\alias{read_coverage}
\alias{read_coverage_table}
\title{Read a coverage TSV file created by Megadepth}
\usage{
read_coverage(tsv_file, verbose = TRUE)

read_coverage_table(tsv_file)
}
\arguments{
\item{tsv_file}{A \code{character(1)} specifying the path to the tab-separated
(TSV) file created manually using \code{megadepth_shell()} or on a previous
\code{get_coverage()} run.}

\item{verbose}{A \code{logical(1)} controlling whether to suppress messages when
reading the data.}
}
\value{
A \link[GenomicRanges:GRanges-class]{GRanges-class} object with the
coverage summarization across the annotation ranges.

A \code{tibble::tibble()} with columns \code{chr}, \code{start}, \code{end} and \code{score}.
}
\description{
Read an \verb{*annotation.tsv} file created by \code{get_coverage()} or manually by
the user using Megadepth.
}
\section{Functions}{
\itemize{
\item \code{read_coverage_table()}: Read a coverage TSV file created by Megadepth as
a table

}}
\examples{

## Install if necessary
install_megadepth()

## Locate example BigWig and annotation files
example_bw <- system.file("tests", "test.bam.all.bw",
    package = "megadepth", mustWork = TRUE
)
annotation_file <- system.file("tests", "testbw2.bed",
    package = "megadepth", mustWork = TRUE
)

## Compute the coverage
bw_cov <- get_coverage(example_bw, op = "mean", annotation = annotation_file)
bw_cov

## Read in the coverage file again, using read_coverage()
## First, lets locate the tsv file that was generated by get_coverage()
tsv_file <- file.path(tempdir(), "bw.mean.annotation.tsv")
bw_cov_manual <- read_coverage(tsv_file)
stopifnot(identical(bw_cov, bw_cov_manual))

## To get an RleList object, just like the one you would get
## from using rtracklayer::import.bw(as = "RleList") directly on the
## BigWig file, use:
GenomicRanges::coverage(bw_cov_manual)

## The coverage data can also be read as a `tibble::tibble()`
read_coverage_table(tsv_file)
}
\seealso{
Other Coverage functions: 
\code{\link{get_coverage}()}
}
\concept{Coverage functions}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/get_coverage.R
\name{get_coverage}
\alias{get_coverage}
\title{Compute coverage summarizations across a set of regions}
\usage{
get_coverage(
  bigwig_file,
  op = c("sum", "mean", "max", "min"),
  annotation,
  prefix = file.path(tempdir(), "bw.mean")
)
}
\arguments{
\item{bigwig_file}{A \code{character(1)} with the path to the input BigWig file.}

\item{op}{A \code{character(1)} specifying the summarization operation to
perform.}

\item{annotation}{A \code{character(1)} path to a BED file with the genomic
coordinates you are interested in.}

\item{prefix}{A \code{character(1)} specifying the output file prefix. This
function creates a file called \code{prefix.annotation.tsv} that can be read
again later with \code{read_coverage()}. By default the file is created in
the \code{tempdir()} and will be deleted after you close your R session.}
}
\value{
A \link[GenomicRanges:GRanges-class]{GRanges-class} object with the
coverage summarization across the annotation ranges.
}
\description{
Given an input set of annotation regions, compute coverage summarizations
using Megadepth for a given BigWig file.
}
\details{
Note that the chromosome names (seqnames) in the BigWig file and the
annotation file should use the same format. Otherwise, Megadepth will
return 0 counts.
}
\examples{

## Install if necessary
install_megadepth()

## Next, we locate the example BigWig and annotation files
example_bw <- system.file("tests", "test.bam.all.bw",
    package = "megadepth", mustWork = TRUE
)
annotation_file <- system.file("tests", "testbw2.bed",
    package = "megadepth", mustWork = TRUE
)

## Compute the coverage
bw_cov <- get_coverage(example_bw, op = "mean", annotation = annotation_file)
bw_cov

## If you want to cast this into a RleList object use the following code:
## (it's equivalent to rtracklayer::import.bw(as = "RleList"))
## although in the megadepth case the data has been summarized
GenomicRanges::coverage(bw_cov)

## Checking with derfinder and rtracklayer
bed <- rtracklayer::import(annotation_file)

## The file needs a name
names(example_bw) <- "example"

## Read in the base-pair coverage data
if (!xfun::is_windows()) {
    regionCov <- derfinder::getRegionCoverage(
        regions = bed,
        files = example_bw,
        verbose = FALSE
    )

    ## Summarize the base-pair coverage data.
    ## Note that we have to round the mean to make them comparable.
    testthat::expect_equivalent(
        round(sapply(regionCov[c(1, 3:4, 2)], function(x) mean(x$value)), 2),
        bw_cov$score,
    )

    ## If we compute the sum, there's no need to round
    testthat::expect_equivalent(
        sapply(regionCov[c(1, 3:4, 2)], function(x) sum(x$value)),
        get_coverage(example_bw, op = "sum", annotation = annotation_file)$score,
    )
}
}
\seealso{
Other Coverage functions: 
\code{\link{read_coverage}()}
}
\concept{Coverage functions}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/megadepth.R
\name{megadepth_cmd}
\alias{megadepth_cmd}
\alias{megadepth_shell}
\title{Run Megadepth commands}
\usage{
megadepth_cmd(...)

megadepth_shell(input = ".", ...)
}
\arguments{
\item{...}{Arguments to be passed to \code{system2('megadepth', ...)}, e.g.
\code{annotation(path)} is basically
\code{megadepth_cmd(c('--annotation', path))}
(i.e. run the command \command{megadepth --annotation path}).}

\item{input}{A \code{character(1)} with the path to the input BAM, BigWig or
text file for Megadepth.}
}
\value{
See \code{base::system2()} for the types of output you can generate.

A \code{character()} with the capture of the standard output stream
generated by Megadepth.
}
\description{
Wrapper functions to run Megadepth commands via
\code{\link{system2}('megadepth', ...)}.
}
\section{Functions}{
\itemize{
\item \code{megadepth_cmd()}: Run an arbitrary Megadepth command.

\item \code{megadepth_shell()}: Run an arbitrary Megadepth command.

}}
\examples{

## Install if necessary
install_megadepth()

## Find version
## megadepth_shell() provides an interface more familiar to R users
megadepth_shell(version = TRUE)
## megadepth_cmd() requires using directly the command line syntax for
## Megadepth
megadepth_cmd("--version", stdout = TRUE)

## Compare the help files:
# megadepth_shell() captures the standard output and returns a character()
# megadepth_cmd() shows the standard output on the console
megadepth_shell("--help")
megadepth_cmd("--help")
}
\references{
\code{megadepth_cmd()} is based on blogdown::hugo_cmd() which is available at
\url{https://github.com/rstudio/blogdown/blob/master/R/hugo.R}.

\code{megadepth_shell()} is based on the shell_ls() example from cmdfun which is
available at \url{https://snystrom.github.io/cmdfun/index.html}.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/install.R
\name{install_megadepth}
\alias{install_megadepth}
\title{Install Megadepth}
\usage{
install_megadepth(version = "latest", force = FALSE)
}
\arguments{
\item{version}{A \verb{character(})` specifying the Megadepth version number,
e.g., \code{1.0.4}; the special value \code{latest} means the latest version
(fetched from Github releases).}

\item{force}{A \code{logical(1)} specifying whether to install megadepth even if
it has already been installed.}
}
\value{
Returns \code{NULL}. The main use is to install Megadepth.
}
\description{
Download the appropriate Megadepth executable for your platform from Github
and try to copy it to a system directory so \pkg{megadepth} can run the
\command{megadepth} command.
}
\details{
If this function is run in an non-interactive session such as \code{R CMD
Check}, it will install Megadepth to \code{tempdir()}. If this function is
run interactively, the user will be prompted to agree to allow Megadepth to
be installed at \code{Sys.getenv('APPDATA')} on Windows,
\file{~/Library/Application Support} on macOS, and \file{~/bin/} on other
platforms (such as Linux). If these directories are not writable, the package
directory \file{Megadepth} of \pkg{megadepth} will be used. If it still
fails, you have to install Megadepth by yourself and make sure it can be
found via the environment variable \code{PATH}.

If you want to install Megadepth to a custom path, you can set the global
option \code{megadepth.dir} to a directory to store the Megadepth executable
before you call \code{install_megadepth()}, e.g.,
\code{options(megadepth.hugo.dir = '~/Downloads/Megadepth_1.0.4/')}.
This may be useful for you to use a specific
version of Megadepth for a specific project. You can set this option per
project, similar to how \code{blogdown.hugo.dir} is used for specifying
the directory for Hugo in the \pkg{blogdown} package..
See \href{https://bookdown.org/yihui/blogdown/global-options.html}{Section
1.4 Global options} for details, or store a copy of Megadepth on a USB Flash
drive along with your project code.
}
\examples{

## Install megadepth
install_megadepth()
}
\references{
This function is based on blogdown::install_hugo() which is available from
\url{https://github.com/rstudio/blogdown/blob/master/R/install.R}.
}
